unit uXMLFuncs;

interface

function TransformDoc(AXMLDocument: string; ATemplateName: string): string;

function ValidateDoc(AXMLDocument: string; ASchemaName: string): boolean;

implementation

uses
  XMLIntf, XMLDoc, XMLDom;

function TransformDoc(AXMLDocument: string; ATemplateName: string): string;
begin

  FXSLTransform.LoadFromFile(edtXSLTFile.Text);
  try
    FXMLDocument.Node.TransformNode(FXSLTransform.Node, Output);
  except on E:Exception do
    MessageDlg('Transform error: ' + E.Message, mtError, [mbOK], 0);
  end;

  OutStream := TStringStream.Create(Output);
  try
    TransformedXML := TXMLDocument.Create(nil);
    try
      TransformedXML.LoadFromStream(OutStream);

      ResultsNode := TransformedXML.ChildNodes.FindNode('RESULTS');
      for I := 0 to ResultsNode.ChildNodes.Count - 1 do
      begin
        RecordIDNode := ResultsNode.ChildNodes[I].AddChild('OBS_ID');
        if CoCreateGUID(UUID) = S_OK then
          RecordIDNode.NodeValue := GUIDToString(UUID)
        else
          raise Exception.Create('Unable to create GUID');
      end;
      mmoPostXML.Lines.Text := Output;
    finally
      TransformedXML := nil;
    end;
  finally
    FreeAndNil(OutStream);
  end;
end;

function ValidateDoc(AXMLDocument: string; ASchemaName: string): boolean;
begin
end;

end.
