unit uConstants;

interface

const
  INVALIDDATA = 'invaliddata';
  ID = 'id';
  PATIENTS = 'patients';
  PATIENT = 'patient';
  FIRSTNAME = 'firstname';
  MIDDLENAME = 'middlename';
  LASTNAME ='lastname';
  DFN = 'dfn';
  SSAN = 'ssan';
  MOTHERSMAIDENNAME = 'mothersmaidenname';
  DOB = 'dateofbirth';
  SEX ='sex';
  ALIAS ='alias';
  RACE ='race';
  ADDRESS = 'address';
  STREET1 = 'street1';
  STREET2 = 'street2';
  CITY = 'city';
  STATE = 'state';
  ZIP = 'zip';

  VALUE_TYPE_ID: array [0..24] of string =
    (
    'AD',
    'CE',
    'CF',
    'CK',
    'CN',
    'CP',
    'CX',
    'DT',
    'ED',
    'FT',
    'MO',
    'NM',
    'PN',
    'RP',
    'SN',
    'ST',
    'TM',
    'TN',
    'TS',
    'TX',
    'XAD',
    'XCN',
    'XON',
    'XPN',
    'XTN');

  ABNORMAL_TYPE_ID: array [0..18] of string =
    (
    'L',
    'H',
    'LL',
    'HH',
    '<',
    '>',
    'N',
    'A',
    'AA',
    'null',
    'U',
    'D',
    'B',
    'W',
    'S',
    'R',
    'I',
    'MS',
    'VS'
    );

  DEVICES = 'devices';
  DEVICE = 'device';
  NAME = 'name';
  OBRSEGMENT = 'obrsegment';
  ORCSEGMENT = 'orcsegment';
  DTYPES = 'devicetypes';
  DTYPE = 'devicetype';
  FTYPE = 'type';
  DESCRIPTION = 'description';

  FIELDSEP = 'fieldsep';
  ENCODINGCHARS = 'encodingchars';
  SENDINGAPP = 'sendingapp';
  SENDINGFACILITY = 'sendingfacility';
  RECEIVINGAPP = 'receivingapp';
  RECEIVINGFACILITY = 'receivingfacility';
  MESSAGETYPE = 'messagetype';
  EVENTTYPE = 'eventtype';
  MESSAGECONTROL_ID = 'messagecontrolid';
  PROCESSING_CODE = 'processingcode';
  VERSION_ID = 'versionid';
  SENDALLATONCE = 'sendallobsatonce';
  
  PRECISION = 'precision';
  ERRORDATA = 'errordata';
  ERRORPERCENTAGE = 'errorpercentage';
  RANGEHI = 'rangehi';
  RANGELO = 'rangelo';
  OBSERVATIONIDENTIFIER = 'observationidentifier';
  OBSERVATIONSUBID = 'observationsubid';
  OBSERVATIONVALUE = 'observationvalue';
  ABNORMALFLAGS = 'abnormalflags';
  PROBABILITY = 'probability';
  ABNORMALNATURE = 'abnormalnature';
  OBSERVATIONRESULTSTATUS = 'observationresultstatus';
  REFRANGEEFFDATE = 'refrangeeffdate';
  USERDEFINEDACCESSCHECKS = 'userdefinedaccesschecks';
  PRODUCERID = 'producerid';
  RESPONSIBLEOBSERVER = 'responsibleobserver';
  OBSERVATIONMETHOD = 'observationmethod';
  EQUIPMENTINSTANCEIDENTIFIER = 'equipmentinstanceidentifier';
  FREQUENCY = 'frequency';
  DIRECTVALUE = 'directvalue';
  OBX = 'OBX';
  MSH = 'MSH';
  BLANK = ' ';
  SCENARIOS = 'scenarios';
  SCENARIO = 'scenario';
  WARD = 'ward';
  BEDS = 'beds';
  BED = 'bed';

  //Replace strings
  REP_TODAY = '<%TODAY%>';
  REP_NOW = '<%NOW%>';
  REP_ID = '<%ID%>'; // will be current date time down to the millisecond.

  // Format strings
  DATE_ = 'yyyymmdd';
  DATE_TIME = 'yyyymmddhhnnss';
  DATE_TIME_MS = 'yyyymmddhhnnsszzz';

function Replace(const Value: string): string;


implementation

uses
  SysUtils;

function Replace(const Value: string): string;
begin
  result := StringReplace(Value, REP_TODAY, FormatDateTime(DATE_, now), [rfReplaceAll, rfIgnoreCase]);
  result := StringReplace(result, REP_NOW, FormatDateTime(DATE_TIME, now), [rfReplaceAll, rfIgnoreCase]);
  result := StringReplace(result, REP_ID, FormatDateTime(DATE_TIME_MS, now), [rfReplaceAll, rfIgnoreCase]);
end;

end.
