unit fMainForm;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 7 $  $Modtime: 10/18/11 11:40a $
*       Developer:    petit           
*       Site:         Hines OIFO
*
*       Description:  Developer Testing Unit.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Flowsheets/CliO/source/TGridFrame/fMainForm.pas $
*
* $History: fMainForm.pas $
 * 
 * *****************  Version 7  *****************
 * User: Vhaishjuergb Date: 11/02/11   Time: 5:33p
 * Updated in $/CP Flowsheets/CliO/source/TGridFrame
 * 
 * *****************  Version 6  *****************
 * User: Vhaishjuergb Date: 5/28/09    Time: 10:53a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Build 275
 * 
 * *****************  Version 5  *****************
 * User: Vhaishpetitd Date: 10/15/08   Time: 12:37p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 4  *****************
 * User: Vhaishpetitd Date: 10/13/07   Time: 2:35p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 8/10/07    Time: 4:09p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 8/08/07    Time: 10:52a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 3/21/07    Time: 1:58p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 5  *****************
 * User: Vhaishpetitd Date: 12/11/06   Time: 1:58p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Demo released to testing and documentation
 *
 * *****************  Version 4  *****************
 * User: Vhaishpetitd Date: 11/24/06   Time: 4:28p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Implementation of non-modal input in the main form.
 *
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 11/09/06   Time: 3:03p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Weekly update of all changes.
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 10/23/06   Time: 4:07p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Finished Pivots, Parser Key, and Totals.
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 10/05/06   Time: 12:59p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Printers,
  iCliOGrid,
  StdCtrls,
  XPMan,
  ExtCtrls;

type
  TfrmMain = class(TForm)
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    Panel2: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  protected
    function getWidgets(aList: IInterfaceList): integer; stdcall;
    function getWidgetIndex(aGridInterface: IInterface; aWidget: IInterface): integer; stdcall;
    function getWidgetProperties(aItem: IInterface): boolean; stdcall;
    function getWidgetInTerm(a1, a2: IInterface): boolean; stdcall;
    function CloseMe(aGridInterface: IInterface): boolean; stdcall;
  end;

var
  frmMain: TfrmMain;

implementation

uses
  DateUtils,
  oWidget;

var
  MyGridFrame: IGridFrame;
  MyItems: IInterfaceList;

const
  NOTE_TITLES: array[0..5] of string = ('Progress Note', 'Social Work Assessment', 'Lab Results', 'Patient Education', 'Radiology Procedure Report', 'EKG Assessment');

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: integer;
  x: string;
  aWidget: IWidget;
begin
  DoubleBuffered := True;
  Font := Screen.IconFont;
  MyItems := TInterfaceList.Create;
  //i := 20;
  i := MinuteOfTheDay(Now);

  Randomize;
  while MyItems.Count < 100 do
    MyItems.Add(
      NewWidget(
      IncMinute(trunc(Now), Random(i)),
      Format('Widget-%d', [Random(4) + 1]),
      NOTE_TITLES[Random(6)], 'A comment'));

  x := '';
  for i := 0 to MyItems.Count - 1 do
    if MyItems[i].QueryInterface(IWidget, aWidget) = 0 then
      x := x +
        FormatDateTime('YYYY-MM-DD hh:mm:ss = ', aWidget.getDateTime) +
        ' Term: ' + aWidget.getTermName + #13 +
        aWidget.getDisplayValue + #13;

  ShowMessage('List:' + #13 + x);

  MyGridFrame := NewGridFrame(ScrollBox1, nil);

  with MyGridFrame do
    try
      BeginUpdate;
      OnGridFetchData := getWidgets;
      OnGridFindTerm := getWidgetIndex;
      OnGridClickItem := getWidgetProperties;
      OnGridIsItemInTerm := getWidgetInTerm;

      //AddTerm(NewGridTerm('Notes', 450));
      AddTerm(NewGridTerm('Widget-1', 200));
      AddTerm(NewGridTerm('Widget-2', 200));
      AddTerm(NewGridTerm('Widget-3', 200));
      AddTerm(NewGridTerm('Widget-4', 200));

      setTitle('Progress Notes and other widgets');
      setTermsOnXAxis(False);
      setInterval(240);
      setExpanded(True);

      setIncludeTotals(False);
      setIncludeCounts(True);
      setIncludeAverages(False);
      setStartDate(trunc(Now));
      setStopDate(trunc(Now) + EncodeTime(23, 59, 59, 0));
    finally
      EndUpdate;
    end;
  MyGridFrame.Refresh;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MyGridFrame := nil;
  Action := caFree;
end;

function TfrmMain.getWidgetProperties(aItem: IInterface): boolean;
var
  aGridItem: IGridItem;
begin
  result := False;
  if aItem.QueryInterface(IGridItem, aGridItem) = 0 then
    begin
      MessageDlg(
        'Welcome to the developer designed YouClickedIt method.' + #13 +
        'You clicked on ' + aGridItem.getDisplayValue + ' somwhere and got sent here.',
        mtInformation, [mbOk], 0);
      Result := True;
    end;
  aGridItem := nil;
end;

function TfrmMain.getWidgetIndex(aGridInterface: IInterface; aWidget: IInterface): integer;
begin
  Result := 0;
end;

function TfrmMain.getWidgets(aList: IInterfaceList): integer;
var
  i: integer;
begin
  aList.Clear;
  for i := 0 to MyItems.Count - 1 do
    aList.Add(MyItems[i]);
  Result := aList.Count;
end;

function TfrmMain.getWidgetInTerm(a1, a2: IInterface): boolean;
var
  aWidget: IWidget;
  aTerm: IGridTerm;
begin
  Result := False;
  if a1.QueryInterface(IWidget, aWidget) = 0 then
    if a2.QueryInterface(IGridTerm, aTerm) = 0 then
      Result := (aWidget.getTermName = aTerm.getDisplayName);
end;

function TfrmMain.CloseMe(aGridInterface: IInterface): boolean;
begin
  ShowMessage('Request made to close grid');
  result := true;
end;

end.

