unit iCliOGrid;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 14 $  $Modtime: 11/18/11 3:16p $
*       Developer:    petit           
*       Site:         Hines OIFO
*
*       Description:  Gridview interfaces.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Flowsheets/CliO/source/TGridFrame/iCliOGrid.pas $
*
* $History: iCliOGrid.pas $
 * 
 * *****************  Version 14  *****************
 * User: Vhaishjuergb Date: 11/29/11   Time: 3:23p
 * Updated in $/CP Flowsheets/CliO/source/TGridFrame
 * 
 * *****************  Version 13  *****************
 * User: Vhaishjuergb Date: 11/02/11   Time: 5:33p
 * Updated in $/CP Flowsheets/CliO/source/TGridFrame
 * 
 * *****************  Version 12  *****************
 * User: Vhaishpetitd Date: 7/30/09    Time: 3:13p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * 
 * *****************  Version 11  *****************
 * User: Vhaishjuergb Date: 2/19/09    Time: 10:28a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * 
 * *****************  Version 10  *****************
 * User: Vhaishjuergb Date: 2/06/09    Time: 10:10a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Post 508 Merge: with views working in 508 mode and toolbars fixed
 * 
 * *****************  Version 8  *****************
 * User: Vhaishpetitd Date: 6/27/08    Time: 5:40p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * 
 * *****************  Version 7  *****************
 * User: Vhaishpetitd Date: 6/13/08    Time: 4:14p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 6  *****************
 * User: Vhaishpetitd Date: 5/14/08    Time: 12:30p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 5  *****************
 * User: Vhaishpetitd Date: 5/01/08    Time: 1:47p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 4  *****************
 * User: Vhaishpetitd Date: 4/13/08    Time: 8:55p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 3/13/08    Time: 9:02p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 3/08/08    Time: 9:55p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 11/10/07   Time: 12:58p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 11  *****************
 * User: Vhaishpetitd Date: 10/13/07   Time: 2:36p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 10  *****************
 * User: Vhaishpetitd Date: 8/25/07    Time: 3:12p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 9  *****************
 * User: Vhaishpetitd Date: 8/08/07    Time: 10:52a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 8  *****************
 * User: Vhaishpetitd Date: 5/29/07    Time: 6:59a
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 7  *****************
 * User: Vhaishpetitd Date: 2/23/07    Time: 1:59p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Post CMO conference
 *
 * *****************  Version 6  *****************
 * User: Vhaishpetitd Date: 12/15/06   Time: 4:08p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * End of year check-in.
 *
 * *****************  Version 5  *****************
 * User: Vhaishpetitd Date: 12/11/06   Time: 1:59p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Demo released to testing and documentation
 *
 * *****************  Version 4  *****************
 * User: Vhaishpetitd Date: 11/24/06   Time: 4:28p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Implementation of non-modal input in the main form.
 *
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 11/09/06   Time: 3:04p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Weekly update of all changes.
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 10/23/06   Time: 4:07p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Finished Pivots, Parser Key, and Totals.
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 10/05/06   Time: 1:00p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  SysUtils,
  Classes,
  Types,
  Graphics,
  Controls,
  StdCtrls,
  Menus,
  Forms,
  oCPTypes;

type
  TGridInterval = (gi1, gi2, gi5, gi10, gi15, gi20, gi30, gi60, gi90, gi120, gi180, gi240, gi360, gi480, gi720, gi1440);
  TGridStyle = (gsTerminologyList, gsDateTimeList);
  TGridFlag = (gfNone, gfInfo, gfWarning, gfError);

  IGridFrame = interface;
  IGridDateTime = interface;
  IGridTerm = interface;
  IGridItem = interface;

  TOnGridFetchData = function(aList: IInterfaceList): integer of object; stdcall;
  TOnGridFetchTotal = function(aList: IInterfaceList; aTerm: IInterface): string of object; stdcall;
  TOnGridFetchAverage = function(aList: IInterfaceList; aTerm: IInterface): string of object; stdcall;
  TOnGridFetchCount = function(aList: IInterfaceList; aTerm: IInterface): integer of object; stdcall;
  TOnGridFetchMinValue = function(aList: IInterfaceList; aTerm: IInterface): string of object; stdcall;
  TOnGridFetchMaxValue = function(aList: IInterfaceList; aTerm: IInterface): string of object; stdcall;
  TOnGridFindTerm = function(aGridInterface: IInterface; aGridItem: IInterface): Integer of object; stdcall;
  TOnGridIsItemInTerm = function(aGridItem, aGridTerm: IInterface): boolean of object; stdcall;
  TOnGridClickItem = function(aItem: IInterface): boolean of object; stdcall;
  TOnGridInsertData = function(aGridInterface: IInterface): boolean of object; stdcall;
  TOnGridPrintData = function(aGridInterface: IInterface): boolean of object; stdcall;
  TOnGridClose = function(aGridInterface: IInterface): boolean of object; stdcall;
  TOnGridGetItemFont = function(aItem: IInterface; var aFont: TFont): boolean of object; stdcall;
  TOnGridGetItemColor = function(aItem: IInterface; var aColor: TColor): boolean of object; stdcall;
  TOnGridGetItemFlag = function(aItem: IInterface): TGridFlag of object; stdcall;
  TOnGridProperties = function(aGridInterface: IInterface): boolean of object; stdcall;
  TOnGridSynchNeeded = function(aGrid: IInterface; aTopRow: integer; aLeftCol: integer): boolean of object; stdcall;

  IGridTerm = interface
    ['{47BB973A-BCA0-4419-8B46-8C05BDBB1065}']
    function getDisplayName: string; stdcall;
    function getDisplayWidth: integer; stdcall;
    function getDisplayTotal: boolean; stdcall;
    function getDisplayCount: boolean; stdcall;
    function getDisplayAverage: boolean; stdcall;
    function getDisplayMinValue: boolean; stdcall;
    function getDisplayMaxValue: boolean; stdcall;
    function getDisplayOnly: boolean; stdcall;
    function getDisplayInCellTotal: boolean; stdcall;
  end;

  IGridItem = interface
    ['{96C8D6CE-30C4-4CA3-8E7E-74A2AE191CF4}']
    function getDateTime: TDateTime; stdcall;
    function getDisplayValue: string; stdcall;
    function getNumericValue: Double; stdcall;
    function getDisplayFontStyle: TFontStyles; stdcall;
    function getDisplayFontColor: TColor; stdcall;
    function getDisplayFlag: TGridFlag; stdcall;
    function getComment: string; stdcall;
  end;

  IGridDateTime = interface
    ['{13F0B610-D7D2-469E-B612-D56BB5998C33}']
    function getDate: string; stdcall;
    function getTime: string; stdcall;
    function getDateTime: string; stdcall;
    function DateTime: TDateTime; stdcall;
  end;

  IGridFrame = interface
    ['{5849DFAA-0365-40D6-83BC-5B07ACCD0E89}']
    {Grid display property methods}
    function getInterface: IInterface; stdcall;
    function getID: string; stdcall;
    function getHeight: integer; stdcall;
    function getInterval: integer; stdcall;
    function getTitle: string; stdcall;
    function getExpanded: boolean; stdcall;
    function getTermsOnXAxis: boolean; stdcall;
    function getStartDate: TDateTime; stdcall;
    function getStopDate: TDateTime; stdcall;
    function getIncludeTotals: boolean; stdcall;
    function getIncludeCounts: boolean; stdcall;
    function getIncludeAverages: boolean; stdcall;
    function getIncludeMinValue: boolean; stdcall;
    function getIncludeMaxValue: boolean; stdcall;
    function getAllowPivot: boolean; stdcall;
    function getInCellTotals: boolean; stdcall;
    function getGridWidth: integer; stdcall;
    function getRowCount: integer; stdcall;
    function getRowHeight(aRow: integer): integer; stdcall;
    function getColCount: integer; stdcall;
    function getColWidth(aCol: integer): integer; stdcall;
    function getMenu: TMenuItem; stdcall;
    function getForm: TForm; stdcall;

    procedure setInterval(const Value: integer); stdcall;
    procedure setTitle(const Value: string); stdcall;
    procedure setExpanded(const Value: boolean); stdcall;
    procedure setTermsOnXAxis(const Value: boolean); stdcall;
    procedure setStartDate(const Value: TDateTime); stdcall;
    procedure setStopDate(const Value: TDateTime); stdcall;
    procedure setIncludeTotals(const Value: boolean); stdcall;
    procedure setIncludeCounts(const Value: boolean); stdcall;
    procedure setIncludeAverages(const Value: boolean); stdcall;
    procedure setIncludeMinValue(const Value: boolean); stdcall;
    procedure setIncludeMaxValue(const Value: boolean); stdcall;
    procedure setAllowPivot(const Value: boolean); stdcall;
    procedure setInCellTotals(const Value: boolean); stdcall;
    procedure setInsertCaption(const Value: string; aHint: string); stdcall;

    //Added to support supplemental info blj 18 November 2011
    procedure setSupplementalMethod(AValue: string); stdcall;
    procedure setSupplementalPosition(AValue: string); stdcall;
    procedure setSupplementalLocation(AValue: string); stdcall;
    procedure setSupplementalProduct(AValue: string); stdcall;
    procedure setPageType(AValue: TCPFlowsheetPageType);stdcall;


    {Set the callback methods}
    function getGridFetchData: TOnGridFetchData; stdcall;
    function getGridFetchTotal: TOnGridFetchTotal; stdcall;
    function getGridFetchAverage: TOnGridFetchAverage; stdcall;
    function getGridFetchCount: TOnGridFetchCount; stdcall;
    function getGridFetchMinValue: TOnGridFetchMinValue; stdcall;
    function getGridFetchMaxValue: TOnGridFetchMaxValue; stdcall;
    function getGridFindTerm: TOnGridFindTerm; stdcall;
    function getGridClickTerm: TOnGridClickItem; stdcall;
    function getGridInsertData: TOnGridInsertData; stdcall;
    function getGridPrintData: TOnGridPrintData; stdcall;
    function getGridIsItemInTerm: TOnGridIsItemInTerm; stdcall;
    function getGridGetItemFont: TOnGridGetItemFont; stdcall;
    function getGridGetItemColor: TOnGridGetItemColor; stdcall;
    function getGridGetItemFlag: TOnGridGetItemFlag; stdcall;
    function getGridProperties: TOnGridProperties; stdcall;
    function getGridSynchNeeded: TOnGridSynchNeeded; stdcall;

    procedure setGridFetchData(const Value: TOnGridFetchData); stdcall;
    procedure setGridFetchTotal(const Value: TOnGridFetchTotal); stdcall;
    procedure setGridFetchAverage(const Value: TOnGridFetchAverage); stdcall;
    procedure setGridFetchCount(const Value: TOnGridFetchCount); stdcall;
    procedure setGridFetchMinValue(const Value: TOnGridFetchMinValue); stdcall;
    procedure setGridFetchMaxValue(const Value: TOnGridFetchMaxValue); stdcall;
    procedure setGridFindTerm(const Value: TOnGridFindTerm); stdcall;
    procedure setGridClickTerm(const Value: TOnGridClickItem); stdcall;
    procedure setGridInsertData(const Value: TOnGridInsertData); stdcall;
    procedure setGridPrintData(const Value: TOnGridPrintData); stdcall;
    procedure setGridIsItemInTerm(const Value: TOnGridIsItemInTerm); stdcall;
    procedure setGridGetItemFont(const Value: TOnGridGetItemFont); stdcall;
    procedure setGridGetItemColor(const Value: TOnGridGetItemColor); stdcall;
    procedure setGridGetItemFlag(const Value: TOnGridGetItemFlag); stdcall;
    procedure setGridProperties(const Value: TOnGridProperties); stdcall;
    procedure setGridSynchNeeded(const Value: TOnGridSynchNeeded); stdcall;

    {Other Methods}
    procedure BeginUpdate; stdcall;
    procedure EndUpdate; stdcall;
    procedure DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect); stdcall;
    procedure LockGrid(aInterval: integer; aGridStyle: TGridStyle); stdcall;
    procedure UnLockGrid; stdcall;
    procedure SynchGrid(aMasterGrid: IInterface; aTopRow: integer; aLeftCol: integer); stdcall;

    procedure AddTerm(aGridTerm: IGridTerm); stdcall;
    procedure AddTermList(aInterfaceList: IInterfaceList); stdcall;
    function FirstTerm: IGridTerm; stdcall;
    function NextTerm(aGridTerm: IGridTerm): IGridTerm; stdcall;
    function Term(index: integer): IGridTerm; stdcall;
    function TermCount: integer; stdcall;
    procedure ClearAllData; stdcall;
    procedure Refresh; stdcall;

    {Method Properties}
    property OnGridFetchData: TOnGridFetchData read getGridFetchData write setGridFetchData;
    property OnGridFetchTotal: TOnGridFetchTotal read getGridFetchTotal write setGridFetchTotal;
    property OnGridFetchAverage: TOnGridFetchAverage read getGridFetchAverage write setGridFetchAverage;
    property OnGridFetchCount: TOnGridFetchCount read getGridFetchCount write setGridFetchCount;
    property OnGridFetchMinValue: TOnGridFetchMinValue read getGridFetchMinValue write setGridFetchMinValue;
    property OnGridFetchMaxValue: TOnGridFetchMaxValue read getGridFetchMaxValue write setGridFetchMaxValue;

    property OnGridFindTerm: TOnGridFindTerm read getGridFindTerm write setGridFindTerm;
    property OnGridClickItem: TOnGridClickItem read getGridClickTerm write setGridClickTerm;
    property OnGridInsertData: TOnGridInsertData read getGridInsertData write setGridInsertData;
    property OnGridPrintData: TOnGridPrintData read getGridPrintData write setGridPrintData;
    property OnGridIsItemInTerm: TOnGridIsItemInTerm read getGridIsItemInTerm write setGridIsItemInTerm;
    property OnGridGetItemFont: TOnGridGetItemFont read getGridGetItemFont write setGridGetItemFont;
    property OnGridGetItemColor: TOnGridGetItemColor read getGridGetItemColor write setGridGetItemColor;
    property OnGridGetItemFlag: TOnGridGetItemFlag read getGridGetItemFlag write setGridGetItemFlag;
    property OnGridProperties: TOnGridProperties read getGridProperties write setGridProperties;
    property OnGridSynchNeeded: TOnGridSynchNeeded read getGridSynchNeeded write setGridSynchNeeded;
  end;

const
  GRID_INTERVAL_VALUE: array[TGridInterval] of integer = (
    1, 2, 5, 10, 15, 20, 30, 60, 90, 120, 180, 240, 360, 480, 720, 1440);

  GRID_INTERVAL_NAME: array[TGridInterval] of string = (
    '1 Minute', {0}
    '2 Minutes', {1}
    '5 Minutes', {2}
    '10 Minutes', {3}
    '15 Minutes', {4}
    '20 Minutes', {5}
    '30 Minutes', {6}
    '1 Hour', {7}
    '90 Minutes', {8}
    '2 Hours', {9}
    '3 Hours', {10}
    '4 Hours', {11}
    '6 Hours', {12}
    '8 Hours', {13}
    '12 Hours', {14}
    '24 Hours'); {15}

  GRID_STYLE_NAME: array[TGridStyle] of string = ('Terminology List', 'Date/Time List');

function OldGridFrame(aOwner: TWinControl; aID: string): IGridFrame;
function NewGridFrame(aOwner: TWinControl; aInterface: IInterface; aTop: integer = 0; aActive: boolean = True): IGridFrame;
function NewGridTerm(aDisplayName: string; aDisplayWidth: integer): IGridTerm;
function GetUniqueComponentName: string;
procedure LoadIntervals(aList: TStrings);
procedure LoadStyles(aList: TStrings);

implementation

uses
  mGridFrame,
  oGridTerm,
  StrUtils;

function NewGridFrame(aOwner: TWinControl; aInterface: IInterface; aTop: integer = 0; aActive: boolean = True): IGridFrame;
var
  AFrame: TFraGridFrame;
begin
  AFrame := NewTfraGridFrame(aOwner, aInterface, aActive);
  with AFrame do
    begin
      Parent := aOwner;
      Title := 'New Frame';
      Expanded := True;
      Top := aTop;
      EndUpdate;
    end;
  Result := AFrame;
end;

function OldGridFrame(aOwner: TWinControl; aID: string): IGridFrame;
begin
  with NewTfraGridFrame(aOwner, aID) do
    begin
      Parent := aOwner;
      Title := 'New Frame';
      Expanded := True;
      EndUpdate;
      GetInterface(IGridFrame, Result);
    end;
end;

function NewGridTerm(aDisplayName: string; aDisplayWidth: integer): IGridTerm;
begin
  TGridTerm.Create(aDisplayName, aDisplayWidth).GetInterface(IGridTerm, Result);
end;

function GetUniqueComponentName: string;
var
  aGUID: TGUID;
begin
  CreateGUID(aGUID);
  Result := GUIDToString(aGUID);
  Result := AnsiReplaceStr(Result, '{', '');
  Result := AnsiReplaceStr(Result, '}', '');
  Result := AnsiReplaceStr(Result, '-', '');
  Result := 'x_' + Result;
end;

procedure LoadIntervals(aList: TStrings);
var
  aItem: TGridInterval;
begin
  for aItem := Low(TGridInterval) to High(TGridInterval) do
    aList.Add(GRID_INTERVAL_NAME[aItem]);
end;

procedure LoadStyles(aList: TStrings);
var
  aItem: TGridStyle;
begin
  for aItem := Low(TGridStyle) to High(TGridStyle) do
    aList.Add(GRID_STYLE_NAME[aItem]);
end;

end.

