unit mGridFrame;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 31 $  $Modtime: 11/28/11 2:44p $
*       Developer:    petit           
*       Site:         Hines OIFO
*
*       Description:  Primary frame for a CliO Gridview
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Flowsheets/CliO/source/TGridFrame/mGridFrame.pas $
}

interface

uses
  Windows,
  Messages,
  SysUtils,
  Variants,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  Grids,
  Buttons,
  ActnList,
  ImgList,
  iCliOGrid,
  ComCtrls,
  ToolWin,
  Menus,
  oCPTypes,
  VA508AccessibilityManager,
  fImageList;

type
  TfraGridFrame = class(TForm, IGridFrame)
    pnlViewHeader: TPanel;
    sgGrid: TStringGrid;
    ActionList1: TActionList;
    acInsert: TAction;
    acRemove: TAction;
    acCorrect: TAction;
    acExpandCollapse: TAction;
    acNextPage: TAction;
    acPrevPage: TAction;
    acDisplayResize: TAction;
    acRefreshDisplay: TAction;
    acPivot: TAction;
    cbxInterval: TComboBox;
    acSetInterval: TAction;
    acRefresh: TAction;
    acRefreshGridData: TAction;
    acCheckEdgeBorder: TAction;
    ToolBar1: TToolBar;
    pnlToolbar: TPanel;
    sbtnInsert: TToolButton;
    sbtnPivot: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    pnlTitle: TPanel;
    pnlInterval: TPanel;
    pmn: TPopupMenu;
    lblDisplayInterval: TLabel;
    Bevel1: TBevel;
    acSettings: TAction;
    ToolButton1: TToolButton;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    lblTitle: TLabel;
    sbObservationComments: TStatusBar;
    pnlSupplementalInfo: TPanel;
    lblMagic4: TLabel;
    Panel1: TPanel;
    imgPlusMinus: TImage;
    procedure sgGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure acExpandCollapseExecute(Sender: TObject);
    procedure acRefreshDisplayExecute(Sender: TObject);
    procedure acDisplayResizeExecute(Sender: TObject);
    procedure acPivotExecute(Sender: TObject);
    procedure acSetIntervalExecute(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure acRefreshGridDataExecute(Sender: TObject);
    procedure acInsertExecute(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure sgGridMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure sgGridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure sgGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure FrameResize(Sender: TObject);
    procedure acNextPageExecute(Sender: TObject);
    procedure acPrevPageExecute(Sender: TObject);
    procedure acRemoveExecute(Sender: TObject);
    procedure acCheckEdgeBorderExecute(Sender: TObject);
    procedure acSettingsExecute(Sender: TObject);
    procedure sgGridTopLeftChanged(Sender: TObject);
    procedure pmnPopup(Sender: TObject);
  protected
    fID: string;
    fInterface: IInterface;
    fExpanded: Boolean;
    fGridStyle: TGridStyle;
    fGridInterval: TGridInterval;
    fInterval: integer; {Number of minutes per display block}
    fStartDate: TDateTime;
    fStopDate: TDateTime;
    fStartDateTime: TDateTime;
    fStopDateTime: TDateTime;
    fTotalsRow: boolean;
    fCountsRow: boolean;
    fAveragesRow: boolean;
    fMinValueRow: boolean;
    fMaxValueRow: boolean;
    fAllowPivot: boolean;
    fTitle: string;
    fDisplayFont: TFont;
    fDisplayColor: TColor;
    fInCellTotals: boolean;
    fLocked: boolean;
    fSynchronizing: boolean;

    fMenuItem: TMenuItem;

    fSupplementalMethod: string;
    fSupplementalPosition: string;
    fSupplementalLocation: string;
    fSupplementalProduct: string;

    fPageType: TCPFlowsheetPageType;


    fOnGridFetchData: TOnGridFetchData;
    fOnGridFetchTotal: TOnGridFetchTotal;
    fOnGridFetchAverage: TOnGridFetchAverage;
    fOnGridFetchCount: TOnGridFetchCount;
    fOnGridFetchMinValue: TOnGridFetchMinValue;
    fOnGridFetchMaxValue: TOnGridFetchMaxValue;

    fOnGridFindTerm: TOnGridFindTerm;
    fOnGridIsItemInTerm: TOnGridIsItemInTerm;
    fOnGridClickItem: TOnGridClickItem; {Purposely left at nil on creation}
    fOnGridInsertData: TOnGridInsertData;
    fOnGridPrintData: TOnGridPrintData; {Ditto}
    fOnGridClose: TOnGridClose; {Ditto}
    fOnGridGetItemFont: TOnGridGetItemFont;
    fOnGridGetItemColor: TOnGridGetItemColor;
    fOnGridGetItemFlag: TOnGridGetItemFlag;
    fOnGridProperties: TOnGridProperties;
    fOnGridSynchNeeded: TOnGridSynchNeeded;

    procedure FMenuItemClick(Sender: TObject);
    procedure IntervalItemClick(Sender: TObject);

    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
    function GetSupplementalLabelString: string;
    procedure UpdateSupplementalLabel;

    function fGridFetchData(aList: IInterfaceList): integer; stdcall;
    function fGridFindTermIndex(aGridInterface: IInterface; aGridItem: IInterface): integer; stdcall;
    function fGridFindDateIndex(aItem: IInterface): Integer; stdcall;
    function fGridIsItemInTerm(aItem, aTerm: IInterface): boolean; stdcall;
    function fGridFetchTotal(aList: IInterfaceList; aItem: IInterface): string; stdcall;
    function fGridFetchMinValue(aList: IInterfaceList; aItem: IInterface): string; stdcall;
    function fGridFetchMaxValue(aList: IInterfaceList; aItem: IInterface): string; stdcall;
    function fGridFetchAverage(aList: IInterfaceList; aTerm: IInterface): string; stdcall;
    function fGridFetchCount(aList: IInterfaceList): integer; stdcall;
    function fGridGetItemFont(aItem: IInterface; var aFont: TFont): boolean; stdcall;
    function fGridGetItemColor(aItem: IInterface; var aColor: TColor): boolean; stdcall;
    function fGridGetItemFlag(aItem: IInterface): TGridFlag; stdcall;
    function fGridProperties(aItem: IInterface): boolean; stdcall;

    function getGridStyle: TGridStyle; stdcall;
    procedure setGridStyle(const Value: TGridStyle); stdcall;

    function getInterface: IInterface; stdcall;
    function getID: string; stdcall;
    function getInterval: integer; stdcall;
    function getHeight: integer; stdcall;
    function getTitle: string; stdcall;
    function getExpanded: boolean; stdcall;
    function getTermsOnXAxis: boolean; stdcall;
    function getStartDate: TDateTime; stdcall;
    function getStopDate: TDateTime; stdcall;
    function getIncludeTotals: boolean; stdcall;
    function getIncludeCounts: boolean; stdcall;
    function getIncludeAverages: boolean; stdcall;
    function getIncludeMinValue: boolean; stdcall;
    function getIncludeMaxValue: boolean; stdcall;
    function getAllowPivot: boolean; stdcall;
    function getInCellTotals: boolean; stdcall;
    function getMenu: TMenuItem; stdcall;
    function getForm: TForm; stdcall;

    function getGridFetchData: TOnGridFetchData; stdcall;
    function getGridFetchTotal: TOnGridFetchTotal; stdcall;
    function getGridFetchAverage: TOnGridFetchAverage; stdcall;
    function getGridFetchCount: TOnGridFetchCount; stdcall;
    function getGridFetchMinValue: TOnGridFetchMinValue; stdcall;
    function getGridFetchMaxValue: TOnGridFetchMaxValue; stdcall;
    function getGridFindTerm: TOnGridFindTerm; stdcall;
    function getGridClickTerm: TOnGridClickItem; stdcall;
    function getGridInsertData: TOnGridInsertData; stdcall;
    function getGridPrintData: TOnGridPrintData; stdcall;
    function getGridIsItemInTerm: TOnGridIsItemInTerm; stdcall;
    function getGridGetItemFont: TOnGridGetItemFont; stdcall;
    function getGridGetItemColor: TOnGridGetItemColor; stdcall;
    function getGridGetItemFlag: TOnGridGetItemFlag; stdcall;
    function getGridProperties: TOnGridProperties; stdcall;
    function getGridSynchNeeded: TOnGridSynchNeeded; stdcall;

    function getGridWidth: integer; stdcall;
    function getRowCount: integer; stdcall;
    function getRowHeight(aRow: integer): integer; stdcall;
    function getColCount: integer; stdcall;
    function getColWidth(aCol: integer): integer; stdcall;

    procedure setExpanded(const Value: boolean); stdcall;
    procedure setStartDate(const Value: TDateTime); stdcall;
    procedure setStopDate(const Value: TDateTime); stdcall;
    procedure setInterval(const Value: Integer); stdcall;
    procedure setTitle(const Value: string); stdcall;
    procedure setTermsOnXAxis(const Value: boolean); stdcall;
    procedure setIncludeTotals(const Value: boolean); stdcall;
    procedure setIncludeCounts(const Value: boolean); stdcall;
    procedure setIncludeAverages(const Value: boolean); stdcall;
    procedure setIncludeMinValue(const Value: boolean); stdcall;
    procedure setIncludeMaxValue(const Value: boolean); stdcall;
    procedure setAllowPivot(const Value: boolean); stdcall;
    procedure setInCellTotals(const aValue: boolean); stdcall;
    procedure setInsertCaption(const aValue: string; aHint: string); stdcall;

    procedure setSupplementalMethod(AValue: string); stdcall;
    procedure setSupplementalPosition(AValue: string); stdcall;
    procedure setSupplementalLocation(AValue: string); stdcall;
    procedure setSupplementalProduct(AValue: string); stdcall;
    procedure setPageType(AValue: TCPFlowsheetPageType);stdcall;


    procedure setGridFetchData(const Value: TOnGridFetchData); stdcall;
    procedure setGridFetchTotal(const Value: TOnGridFetchTotal); stdcall;
    procedure setGridFetchAverage(const Value: TOnGridFetchAverage); stdcall;
    procedure setGridFetchCount(const Value: TOnGridFetchCount); stdcall;
    procedure setGridFetchMinValue(const Value: TOnGridFetchMinValue); stdcall;
    procedure setGridFetchMaxValue(const Value: TOnGridFetchMaxValue); stdcall;
    procedure setGridFindTerm(const Value: TOnGridFindTerm); stdcall;
    procedure setGridClickTerm(const Value: TOnGridClickItem); stdcall;
    procedure setGridInsertData(const Value: TOnGridInsertData); stdcall;
    procedure setGridPrintData(const Value: TOnGridPrintData); stdcall;
    procedure setGridIsItemInTerm(const Value: TOnGridIsItemInTerm); stdcall;
    procedure setGridGetItemFont(const Value: TOnGridGetItemFont); stdcall;
    procedure setGridGetItemColor(const Value: TOnGridGetItemColor); stdcall;
    procedure setGridGetItemFlag(const Value: TOnGridGetItemFlag); stdcall;
    procedure setGridProperties(const Value: TOnGridProperties); stdcall;
    procedure setGridSynchNeeded(const Value: TOnGridSynchNeeded); stdcall;

    procedure DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect); stdcall;
    procedure ClearAllGridObjects;
    procedure BuildTimeSlots;
    procedure LoadNewDataSet;
    procedure setUpdating(const Value: boolean);
    procedure setOnGridInsertData(const Value: TOnGridInsertData);

    procedure AddTerm(aGridTerm: IGridTerm); stdcall;
    procedure AddTermList(aInterfaceList: IInterfaceList); stdcall;
    function FirstTerm: IGridTerm; stdcall;
    function NextTerm(aGridTerm: IGridTerm): IGridTerm; stdcall;
    function Term(index: integer): IGridTerm; stdcall;
    function TermCount: integer; stdcall;
    procedure ClearAllData; stdcall;

    procedure LockGrid(aInterval: integer; aGridStyle: TGridStyle); stdcall;
    procedure UnLockGrid; stdcall;

    procedure PmnClick(Sender: TObject);

  public
    fUpdating: boolean;
    fTermList: IInterfaceList;
    fDateList: IInterfaceList;
    fItemList: IInterfaceList;
    fSelectedItems: IInterfaceList;

    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;

    procedure BeginUpdate; stdcall;
    procedure EndUpdate; stdcall;
    procedure Refresh; stdcall;
    procedure SynchGrid(aMasterGrid: IInterface; aTopRow: integer; aLeftCol: integer); stdcall;
    procedure ClearData;
    procedure SetDateRange(aStartDate, aStopDate: TDateTime);

    property GridUpdating: boolean read fUpdating write setUpdating;
    property Expanded: boolean read fExpanded write setExpanded;
    property StartDate: TDateTime read fStartDate write setStartDate;
    property StopDate: TDateTime read fStopDate write setStopDate;
    property TermsOnXAxis: boolean read getTermsOnXAxis write setTermsOnXAxis;
    property Title: string read getTitle write setTitle;
    property AllowPivot: boolean read getAllowPivot write setAllowPivot;
    property InCellTotals: boolean read getInCellTotals write setInCellTotals;
    property OnGridFetchData: TOnGridFetchData read fOnGridFetchData write setGridFetchData;
    property OnGridFindTerm: TOnGridFindTerm read fOnGridFindTerm write setGridFindTerm;
    property OnGridClickItem: TOnGridClickItem read fOnGridClickItem write setGridClickTerm;
    property OnGridInsertData: TOnGridInsertData read fOnGridInsertData write setOnGridInsertData;
    property OnGridGetItemFont: TOnGridGetItemFont read fOnGridGetItemFont write setGridGetItemFont;
    property OnGridGetItemColor: TOnGridGetItemColor read fOnGridGetItemColor write setGridGetItemColor;
    property OnGridGetItemFlag: TOnGridGetItemFlag read fOnGridGetItemFlag write setGridGetItemFlag;
    property OnGridProperties: TOnGridProperties read fOnGridProperties write setGridProperties;
  end;

function NewTfraGridFrame(aOwner: TWinControl; aID: string): TfraGridFrame; overload;
function NewTfraGridFrame(aOwner: TWinControl; aInterface: IInterface; aActive: boolean = True): TfraGridFrame; overload;

implementation

uses
  Printers,
  oGridDateTime,
  DateUtils,
  Types,
  Math,
  VA508AccessibilityRouter,
  oInterfaces,
  oClioTypes,
  uGlobalVars;

var
  HighlightedCell: TPoint;
  HighlightedItem: integer;

const
  BOOL2INT: array[boolean] of integer = (0, 1);
  DISPLAY_INTERVAL = 'Display Interval';

{$R *.dfm}

function NewTfraGridFrame(aOwner: TWinControl; aInterface: IInterface; aActive: boolean = True): TfraGridFrame;
var
  gi: TGridInterval;
  Item: TMenuItem;
  IntervalItem: TMenuItem;
begin
  Result := TfraGridFrame.Create(aOwner);
  with Result do
    begin
      if ScreenReaderSystemActive then
      begin
        sgGrid.DefaultDrawing := true;
        sgGrid.OnDrawCell := nil;
        sgGrid.GridLineWidth := 1;
      end;
      fInterface := aInterface;
      Parent := aOwner;
      DoubleBuffered := True;
      sgGrid.DoubleBuffered := True;
      pnlViewHeader.DoubleBuffered := True;
      pnlTitle.DoubleBuffered := True;
      pnlInterval.DoubleBuffered := True;
      Name := GetUniqueComponentName;
      Top := (aOwner.ComponentCount - 1) * Height;
      Align := alTop;
      lblTitle.Font.Style := [fsBold];
      if not aActive then
       lblTitle.Font.Color := clInactiveCaptionText;
      sgGrid.Canvas.Font := Screen.IconFont;
      sgGrid.DefaultRowHeight := sgGrid.Canvas.TextHeight('|') + 4;
      sgGrid.DefaultColWidth := 120;

      fOnGridFetchData := fGridFetchData;
      fOnGridFetchTotal := fGridFetchTotal;
      fOnGridFetchAverage := fGridFetchAverage;
      fOnGridFetchMinValue := fGridFetchMinValue;
      fOnGridFetchMaxValue := fGridFetchMaxValue;
      fOnGridFindTerm := fGridFindTermIndex;
      fOnGridIsItemInTerm := fGridIsItemInTerm;
      fOnGridGetItemFont := fGridGetItemFont;
      fOnGridGetItemColor := fGridGetItemColor;
      fOnGridGetItemFlag := fGridGetItemFlag;

      fUpdating := True;
      fGridStyle := gsTerminologyList;
      fStartDate := Now;
      fStopDate := Now;
      {Debug for now, set to false in production}
      fTotalsRow := False;
      fCountsRow := False;
      fAveragesRow := False;

      Item := TMenuItem.Create(FMenuItem);
      FMenuItem.Add(Item);
      Item.Caption := DISPLAY_INTERVAL;
      Item.ImageIndex := -1;

      for gi := Low(TGridInterval) to High(TGridInterval) do
      begin
        IntervalItem := TMenuItem.Create(Item);
        Item.ImageIndex := -1;
        Item.Add(IntervalItem);
        IntervalItem.Caption := GRID_INTERVAL_NAME[gi];
        IntervalItem.OnClick := IntervalItemClick;
        cbxInterval.Items.AddObject(GRID_INTERVAL_NAME[gi], IntervalItem);
      end;

      cbxInterval.ItemIndex := Ord(gi480);
      fInterval := 480; {8 hr shift for a default?}

      BuildTimeSlots;
      fUpdating := False;
      Visible := true;
      acInsert.Enabled := not MyUser.HasRole(ROLE_CLIO_READ_ONLY);
      acInsert.Visible := not MyUser.HasRole(ROLE_CLIO_READ_ONLY)
    end;
end;

function NewTfraGridFrame(aOwner: TWinControl; aID: string): TfraGridFrame;
var
  gi: TGridInterval;
  Item,
  IntervalItem: TMenuItem;
begin
  Result := TfraGridFrame.Create(aOwner);
  with Result do
    begin
      if ScreenReaderSystemActive then
      begin
        sgGrid.DefaultDrawing := true;
        sgGrid.OnDrawCell := nil;
        sgGrid.GridLineWidth := 1;
      end;
      fID := aID;
      Parent := aOwner;
      DoubleBuffered := True;
      pnlViewHeader.DoubleBuffered := True;
      Name := GetUniqueComponentName;
      Top := (aOwner.ComponentCount - 1) * Height;
      Align := alTop;
      lblTitle.Font.Style := [fsBold];
      sgGrid.Canvas.Font := Screen.IconFont;
      sgGrid.DefaultRowHeight := sgGrid.Canvas.TextHeight('|') + 4;
      sgGrid.DefaultColWidth := 120;

      fOnGridFetchData := fGridFetchData;
      fOnGridFetchTotal := fGridFetchTotal;
      fOnGridFetchAverage := fGridFetchAverage;
      fOnGridFetchMinValue := fGridFetchMinValue;
      fOnGridFetchMaxValue := fGridFetchMaxValue;
      fOnGridFindTerm := fGridFindTermIndex;
      fOnGridIsItemInTerm := fGridIsItemInTerm;
      fOnGridGetItemFont := fGridGetItemFont;
      fOnGridGetItemColor := fGridGetItemColor;
      fOnGridGetItemFlag := fGridGetItemFlag;

      fUpdating := True;
      fGridStyle := gsTerminologyList;
      fStartDate := Now;
      fStopDate := Now;
      {Debug for now, set to false in production}
      fTotalsRow := False;
      fCountsRow := False;
      fAveragesRow := False;

      Item := TMenuItem.Create(FMenuItem);
      Item.ImageIndex := -1;
      FMenuItem.Add(Item);
      Item.Caption := DISPLAY_INTERVAL;

      for gi := Low(TGridInterval) to High(TGridInterval) do
      begin
        IntervalItem := TMenuItem.Create(Item);
        IntervalItem.Caption := GRID_INTERVAL_NAME[gi];
        IntervalItem.OnClick := IntervalItemClick;
        cbxInterval.Items.AddObject(GRID_INTERVAL_NAME[gi], IntervalItem);
      end;

      cbxInterval.ItemIndex := Ord(gi480);
      fInterval := 480; {8 hr shift for a default?}

      BuildTimeSlots;
      fUpdating := False;
      Visible := true;
    end;
end;

constructor TfraGridFrame.Create(aOwner: TComponent);
var
  aGUID: TGUID;
  Item: TMenuItem;
begin
  if not (aOwner is TWinControl) then
    raise Exception.Create('An owner of a grid frame must be a TWinControl.');
    
  inherited Create(aOwner);
  CreateGUID(aGUID);
  fID := GUIDToString(aGUID);
  fTermList := TInterfaceList.Create;
  fDateList := TInterfaceList.Create;
  fItemList := TInterfaceList.Create;
  fSelectedItems := TInterfaceList.Create;
  fDisplayFont := TFont.Create;
  fInCellTotals := True;
  fLocked := False;
  fSynchronizing := False;

  fMenuItem := TMenuItem.Create(nil);
  FMenuItem.OnClick := FMenuItemClick;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action :=  acInsert;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acPivot;

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acPrevPage;
  Item.Caption := 'Scroll Left';

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acNextPage;
  Item.Caption := 'Scroll Right';

  Item := TMenuItem.Create(FMenuItem);
  FMenuItem.Add(Item);
  Item.Action := acSettings;

end;

destructor TfraGridFrame.Destroy;
begin
  FreeAndNil(fMenuItem);
  FreeAndNil(fDisplayFont);  
  ClearAllGridObjects;
  fSelectedItems.Clear;
  fSelectedItems := nil;
  fTermList.Clear;
  fTermList := nil;
  fDateList.Clear;
  fDateList := nil;
  fItemList.Clear;
  fItemList := nil;
  inherited;
end;

function TfraGridFrame.fGridFetchData(aList: IInterfaceList): integer;
begin
  Result := 0;
end;

function TfraGridFrame.fGridFetchMaxValue(aList: IInterfaceList; aItem: IInterface): string;
var
  i: integer;
  m: Double;
  aGridItem: IGridItem;
begin
  m := 0;
  for i := 0 to aList.Count - 1 do
    if aList[i].QueryInterface(IGridItem, aGridItem) = 0 then
      if i = 0 then
        m := aGridItem.getNumericValue
      else if aGridItem.getNumericValue > m then
        m := aGridItem.getNumericValue;

  if aList.Count > 0 then
    Result := Format('%0.2f', [m])
  else
    Result := '***';
end;

function TfraGridFrame.fGridFetchMinValue(aList: IInterfaceList; aItem: IInterface): string;
var
  i: integer;
  m: Double;
  aGridItem: IGridItem;
begin
  m := 0;
  for i := 0 to aList.Count - 1 do
    if aList[i].QueryInterface(IGridItem, aGridItem) = 0 then
      if i = 0 then
        m := aGridItem.getNumericValue
      else if aGridItem.getNumericValue < m then
        m := aGridItem.getNumericValue;

  if aList.Count > 0 then
    Result := Format('%0.2f', [m])
  else
    Result := '***';
end;

function TfraGridFrame.fGridFindTermIndex(aGridInterface: IInterface; aGridItem: IInterface): integer;
begin
  Result := -1;
end;

function TfraGridFrame.fGridGetItemColor(aItem: IInterface; var aColor: TColor): boolean;
begin
  //aColor := clWindow;
  { Debug
  if aColor = clWindow then
    Result := False
  else
    begin
      aColor := clMoneyGreen;
      Result := True;
    end;
  }
  result := false; //lint
end;

function TfraGridFrame.fGridGetItemFlag(aItem: IInterface): TGridFlag;
begin
  Result := gfNone;
end;

function TfraGridFrame.fGridGetItemFont(aItem: IInterface; var aFont: TFont): boolean;
begin
  { Debug
  aFont.Color := clLime;
  aFont.Style := [fsBold, fsItalic, fsUnderline, fsStrikeOut];
  }
  aFont.Color := clWindowText;
  aFont.Style := [];
  Result := True;
end;

function TfraGridFrame.fGridIsItemInTerm(aItem, aTerm: IInterface): boolean;
begin
  Result := false;
end;

function TfraGridFrame.fGridProperties(aItem: IInterface): boolean;
begin
  Result := False;
end;

function TfraGridFrame.fGridFindDateIndex(aItem: IInterface): Integer;
var
  aGridItem: IGridItem;
  aGridDateTime: IGridDateTime;
begin
  if aItem.QueryInterface(IGridItem, aGridItem) = 0 then
    if aGridItem.getDateTime <= fStopDateTime then
      for Result := fDateList.Count - 1 downto 0 do
        if fDateList[Result].QueryInterface(IGridDateTime, aGridDateTime) = 0 then
          if aGridDateTime.DateTime <= aGridItem.getDateTime then
            Exit;
  Result := -1;
end;

procedure TfraGridFrame.ClearAllGridObjects;
var
  r, c: integer;
begin
  {Clear every single Cells.Objects}
  try
    for r := 0 to sgGrid.RowCount - 1 do
      for c := 0 to sgGrid.ColCount - 1 do
      begin
        if sgGrid.Objects[c, r] <> nil then
          begin
            TInterfaceList(sgGrid.Objects[c, r]).Clear;
            TInterfaceList(sgGrid.Objects[c, r]).Free;
          end;
          sgGrid.Objects[c, r] := nil;
          sgGrid.Cells[c, r] := '';
      end;
  except
    raise Exception.Create('Error clearing grid.');
  end;
end;

procedure TfraGridFrame.Refresh;
begin
  acRefresh.Execute;
end;

procedure TfraGridFrame.AddTerm(aGridTerm: IGridTerm);
begin
  fTermList.Add(aGridTerm);
  acDisplayResize.Execute;
end;

procedure TfraGridFrame.LoadNewDataSet;
begin
  fItemList.Clear;
  if assigned(fOnGridFetchData) then
    fOnGridFetchData(fItemList)
  else
    raise Exception.Create('OnGridFetchData unassigned in TfraGridFrame.LoadNewDataSet!');
end;

procedure TfraGridFrame.LockGrid(aInterval: integer; aGridStyle: TGridStyle);
begin
  setInterval(aInterval);
  setGridStyle(aGridStyle);
  cbxInterval.Enabled := False;
  lblDisplayInterval.Enabled := False;
  fAllowPivot := acPivot.Enabled;
  acPivot.Enabled := False;
  sgGrid.Options := sgGrid.Options - [goRangeSelect];
  fLocked := True;
end;

procedure TfraGridFrame.UnLockGrid;
begin
  cbxInterval.Enabled := True;
  lblDisplayInterval.Enabled := True;
  acPivot.Enabled := fAllowPivot;
  sgGrid.Options := sgGrid.Options + [goRangeSelect];
  fLocked := False;
end;

procedure TfraGridFrame.UpdateSupplementalLabel;
begin
  lblMagic4.Caption := GetSupplementalLabelString;
end;

function TfraGridFrame._AddRef: Integer;
begin
  Result := -1;
end;

function TfraGridFrame._Release: Integer;
begin
  Result := -1;
end;

function TfraGridFrame.getGridStyle: TGridStyle;
begin
  Result := fGridStyle;
end;

function TfraGridFrame.getGridSynchNeeded: TOnGridSynchNeeded;
begin
  Result := fOnGridSynchNeeded;
end;

procedure TfraGridFrame.setGridStyle(const Value: TGridStyle);
begin
  {Apply new style}
  ClearAllGridObjects;
  fGridStyle := Value;
  sgGrid.FixedRows := 0;
  sgGrid.FixedCols := 0;

  case fGridStyle of
    gsTerminologyList: {Terms in column zero, date/time across the top}
      begin
        sgGrid.ColCount := 3;
        sgGrid.ColWidths[0] := 150;
        sgGrid.ColWidths[1] := sgGrid.DefaultColWidth;
        sgGrid.ColWidths[2] := sgGrid.DefaultColWidth;
        sgGrid.FixedCols := 1;
        sgGrid.RowCount := 3;
        sgGrid.RowHeights[0] := sgGrid.DefaultRowHeight;
        sgGrid.RowHeights[1] := sgGrid.DefaultRowHeight;
        sgGrid.RowHeights[2] := sgGrid.DefaultRowHeight;
        if ScreenReaderSystemActive then
          sgGrid.FixedRows := 1
        else
          sgGrid.FixedRows := 2;
      end;
    gsDateTimeList: {Dates in column zero, terms across the top}
      begin
        sgGrid.ColCount := 3;
        sgGrid.Canvas.Font.Style := sgGrid.Canvas.Font.Style + [fsBold];
        sgGrid.ColWidths[0] := sgGrid.Canvas.TextWidth('  XXX-00-00  '); {Date}
        sgGrid.ColWidths[1] := sgGrid.Canvas.TextWidth('  00:00-00:00  '); {Time}
        sgGrid.ColWidths[2] := sgGrid.DefaultColWidth;
        sgGrid.Canvas.Font.Style := sgGrid.Canvas.Font.Style - [fsBold];
        if ScreenReaderSystemActive then
          sgGrid.FixedCols := 1
        else
          sgGrid.FixedCols := 2;
        sgGrid.RowCount := 3;
        sgGrid.RowHeights[0] := sgGrid.DefaultRowHeight;
        sgGrid.RowHeights[1] := sgGrid.DefaultRowHeight;
        sgGrid.RowHeights[2] := sgGrid.DefaultRowHeight;
        sgGrid.FixedRows := 1;
      end;
  end;
  acDisplayResize.Execute;
end;

procedure TfraGridFrame.setGridSynchNeeded(const Value: TOnGridSynchNeeded);
begin
  fOnGridSynchNeeded := Value;
end;

procedure TfraGridFrame.setExpanded(const Value: boolean);
begin
  fExpanded := Value;
  acRefreshDisplay.Execute;
end;

procedure TfraGridFrame.BuildTimeSlots;
var
  aDate: TDate;
  aMin: integer;
  aDateTime: TDateTime;
begin
  fDateList.Clear;
  aDate := Trunc(fStartDate);
  while aDate <= trunc(fStopDate) do
    begin
      aMin := 0;
      while aMin < 1440 do
        begin
          aDateTime := IncMinute(aDate, aMin);
          {Add this filter :)}
          if (aDateTime >= fStartDateTime) and (aDateTime < fStopDateTime) then
            fDateList.Add(NewGridDateTime(aDateTime, fInterval) as IGridDateTime);
          inc(aMin, fInterval);
        end;
      aDate := IncDay(aDate);
    end;
  sgGrid.Invalidate;
end;

procedure TfraGridFrame.SetDateRange(aStartDate, aStopDate: TDateTime);
begin
  fStartDate := Trunc(aStartDate);

  if fStartDate > aStopDate then
    fStopDate := fStartDate
  else
    fStopDate := aStopDate;

  if GridUpdating then
    Exit
  else
    begin
      LoadNewDataSet;
      acDisplayResize.Execute;
    end;
end;

procedure TfraGridFrame.setStartDate(const Value: TDateTime);
begin
  fStartDateTime := Value;
  fStartDate := Trunc(Value);
  if fStartDate > fStopDate then
    fStopDate := fStartDate;

  BuildTimeSlots;

  if GridUpdating then {Allows us to hold back on the db call incase we're setting multiple items}
    Exit
  else {Do the whole thing}
    begin
      LoadNewDataSet;
      acDisplayResize.Execute;
    end;
end;

procedure TfraGridFrame.setStopDate(const Value: TDateTime);
begin
  fStopDateTime := Value;
  fStopDate := Trunc(Value);
  if fStopDate < fStartDate then
    fStartDate := fStopDate;
  BuildTimeSlots;

  if GridUpdating then {Allows us to hold back on the db call incase we're setting multiple items}
    Exit
  else {Do the whole thing}
    begin
      LoadNewDataSet;
      acDisplayResize.Execute;
    end;
end;

procedure TfraGridFrame.setSupplementalLocation(AValue: string);
begin
  fSupplementalLocation := AValue;
  UpdateSupplementalLabel;
end;

procedure TfraGridFrame.setSupplementalMethod(AValue: string);
begin
  fSupplementalMethod := AValue;
  UpdateSupplementalLabel;
end;

procedure TfraGridFrame.setSupplementalPosition(AValue: string);
begin
  fSupplementalPosition := AValue;
  UpdateSupplementalLabel;
end;

procedure TfraGridFrame.setSupplementalProduct(AValue: string);
begin
  fSupplementalProduct := AValue;
  UpdateSupplementalLabel;
end;

procedure TfraGridFrame.setInterval(const Value: Integer);
var
  I: Integer;
  K: Integer;
  Item: TMenuItem;

  procedure CheckItem(AItem: TMenuItem);
  var
    J: Integer;
  begin
    for J := 0 to AItem.Parent.Count - 1 do
      AItem.Parent.Items[J].Checked := false;

    if assigned(AItem) then
      AItem.Checked := true;
  end;
begin
  {if we're running a screen reader, we've got stuff in the cells.  We have to
  clear that out before we rearrange things.}

  for I := 0 to sgGrid.RowCount - 1 do
    for K := 0 to sgGrid.ColCount - 1 do
      sgGrid.Cells[K, I] := '';


  case Value of
    1: fGridInterval := gi1;
    2: fGridInterval := gi2;
    5: fGridInterval := gi5;
    10: fGridInterval := gi10;
    15: fGridInterval := gi15;
    20: fGridInterval := gi20;
    30: fGridInterval := gi30;
    60: fGridInterval := gi60;
    90: fGridInterval := gi90;
    120: fGridInterval := gi120;
    180: fGridInterval := gi180;
    240: fGridInterval := gi240;
    360: fGridInterval := gi360;
    480: fGridInterval := gi480;
    720: fGridInterval := gi720;
    1440: fGridInterval := gi1440;
  else
    fGridInterval := gi1440;
  end;

  fInterval := GRID_INTERVAL_VALUE[fGridInterval];
  cbxInterval.ItemIndex := Ord(fGridInterval);
  Item := TMenuItem(cbxInterval.Items.Objects[cbxInterval.ItemIndex]);
  CheckItem(Item);

  if GridUpdating then
    begin
      BuildTimeSlots;
      Exit;
    end
  else {Do the whole thing except the data grab}
    acDisplayResize.Execute;
end;

procedure TfraGridFrame.setUpdating(const Value: boolean);
begin
  fUpdating := Value;
  if not fUpdating then
    begin
      LoadNewDataSet; {Get the data}
      acDisplayResize.Execute; {Flush!}
    end;
end;

procedure TfraGridFrame.setOnGridInsertData(const Value: TOnGridInsertData);
begin
  fOnGridInsertData := Value;
  sbtnInsert.visible := Assigned(Value);
end;

procedure TfraGridFrame.setPageType(AValue: TCPFlowsheetPageType);
begin
  if fPageType = AValue then
    exit;

  fPageType := AValue;
  if AValue = ptSupplemental then
  begin
    pnlSupplementalInfo.Height := 16;
  end
  else
  begin
    pnlSupplementalInfo.Height := 0;
  end;
end;

procedure TfraGridFrame.sgGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  aGridItem: IGridItem;
  aGridTerm: IGridTerm;
  aGridDateTime: IGridDateTime;
  aValue: string;
  i: integer;
  r: integer;
  aCanvas: TCanvas;
  aItemList: IInterfaceList;

  aTotal: string;
  aTotalRow: boolean;

  aCount: integer;
  aCountRow: boolean;

  aAverage: string;
  aAverageRow: boolean;

  aMinimum: string;
  aMinimumRow: boolean;

  aMaximum: string;
  aMaximumRow: boolean;

  aLabel: string;

  aTimeRect: TRect;
  aDataRect: TRect;
  aTotalRect: TRect;
  (* 508 *)
  aTextRect: TRect;
  aTextValue: string;
  (*     *)

  aTextWidth: integer;
  aTextFlag: TGridFlag;
begin
  if GridUpdating then
    Exit;

  if ScreenReaderSystemActive then
    exit;

  if Sender = sgGrid then
    aCanvas := sgGrid.Canvas
  else
    aCanvas := Sender as TCanvas;

  if ((ACol - sgGrid.LeftCol) >= sgGrid.VisibleColCount) and (Sender = sgGrid) then {Col is not fully viewable and not going to an external canvas}
    begin
      aCanvas.Brush.Color := clWindow;
      aCanvas.FillRect(Rect);
      Exit;
    end;

  {Flag the row type}
  if fGridStyle = gsTerminologyList then
    begin
      aTotalRow := False;
      aCountRow := False;
      aAverageRow := False;
      aMinimumRow := False;
      aMaximumRow := False;
    end
  else
    begin
      aTotalRow := fTotalsRow and
        (aRow - sgGrid.FixedRows = fDateList.Count);
      aCountRow := fCountsRow and
        (aRow - sgGrid.FixedRows = (fDateList.Count + BOOL2INT[fTotalsRow]));
      aAverageRow := fAveragesRow and
        (aRow - sgGrid.FixedRows = (fDateList.Count + BOOL2INT[fTotalsRow] + BOOL2INT[fCountsRow]));
      aMinimumRow := fMinValueRow and
        (aRow - sgGrid.FixedRows = (fDateList.Count + BOOL2INT[fTotalsRow] + BOOL2INT[fCountsRow] + BOOL2INT[fAveragesRow]));
      aMaximumRow := fMaxValueRow and
        (aRow - sgGrid.FixedRows = (fDateList.Count + BOOL2INT[fTotalsRow] + BOOL2INT[fCountsRow] + BOOL2INT[fAveragesRow] + BOOL2INT[fMinValueRow]));
    end;

  if gdFixed in State then
    begin
      aCanvas.Font := Font;
      aCanvas.Brush.Color := clInfoBk;
      aCanvas.FillRect(Rect);

      if Sender = sgGrid then
        aCanvas.Font.Style := [fsBold]; {Don't bold when printing}

      if (aCol >= sgGrid.FixedCols) then {Working across the top}
        case fGridStyle of
          gsTerminologyList:
            if fDateList.Count > 0 then
              begin
                fDateList[aCol - sgGrid.FixedCols].QueryInterface(IGridDateTime, aGridDateTime);

                (* Non-508 *)
                if aRow = 0 then
                  if ((aCol - sgGrid.FixedCols) = 0) or (aCol = sgGrid.LeftCol) then
                  begin
                    aCanvas.TextRect(Rect, Rect.Left + 4, Rect.Top + 2, FormatDateTime('mmm-dd-yy', aGridDateTime.DateTime));
                  end
                  else
                    aCanvas.TextRect(Rect, Rect.Left + 4, Rect.Top + 2, aGridDateTime.getDate)
                else
                  aCanvas.TextRect(Rect, Rect.Left + 4, Rect.Top + 2, aGridDateTime.getTime);
              end;
          gsDateTimeList:
            if fTermList.Count > 0 then
              begin
                fTermList[aCol - sgGrid.FixedCols].QueryInterface(IGridTerm, aGridTerm);
                sgGrid.ColWidths[aCol] := aGridTerm.getDisplayWidth;
                if aGridTerm.getDisplayOnly then
                  aCanvas.Font.Color := cl3DDkShadow
                else
                  aCanvas.Font.Color := clWindowText;
                aCanvas.TextRect(Rect, Rect.Left + 4, Rect.Top + 2, aGridTerm.getDisplayName);
              end;
        end;

      if (aRow >= sgGrid.FixedRows) then {Working down the side}
        case fGridStyle of
          gsTerminologyList:
            if (fTermList.Count > 0) and ((aRow - sgGrid.FixedRows) < fTermList.Count) then
              begin
                fTermList[aRow - sgGrid.FixedRows].QueryInterface(IGridTerm, aGridTerm);
                if aGridTerm.getDisplayOnly then
                  aCanvas.Font.Color := cl3DDkShadow
                else
                  aCanvas.Font.Color := clWindowText;
                aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, aGridTerm.getDisplayName);
                (* 508
                sgGrid.Cells[aCol, aRow] := aGridTerm.getDisplayName;
                (*     *)
              end
            else {Figure out if we're on total, count or average}
              begin
                if aTotalRow then
                  aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, 'Total');
                if aCountRow then
                  aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, 'Count');
                if aAverageRow then
                  aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, 'Average');
                if aMinimumRow then
                  aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, 'Minimum');
                if aMaximumRow then
                  aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, 'Maximum');
              end;
          gsDateTimeList:
            if (fDateList.Count > 0) and ((aRow - sgGrid.FixedRows) < fDateList.Count) then
              begin
                fDateList[aRow - sgGrid.FixedRows].QueryInterface(IGridDateTime, aGridDateTime);

                if aCol = 0 then
                  if (aRow - sgGrid.FixedRows) = 0 then
                    aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, FormatDateTime('mmm-dd-yy', aGridDateTime.DateTime))
                  else
                    aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, aGridDateTime.getDate)
                else
                  aCanvas.TextRect(Rect,Rect.Left + 4, Rect.Top + 2, aGridDateTime.getTime);
                (* 508
                sgGrid.Cells[aCol, aRow] := aGridDateTime.getTime;
                *)
              end
            else {Figure out if we're on total, count or average} if aCol = 0 then
              begin
                if aTotalRow then
                  aCanvas.TextRect(Rect,Rect.Right - aCanvas.TextWidth('Total') - 4, Rect.Top + 2, 'Total');
                if aCountRow then
                  aCanvas.TextRect(Rect,Rect.Right - aCanvas.TextWidth('Count') - 4, Rect.Top + 2, 'Count');
                if aAverageRow then
                  aCanvas.TextRect(Rect,Rect.Right - aCanvas.TextWidth('Average') - 4, Rect.Top + 2, 'Average');
                if aMinimumRow then
                  aCanvas.TextRect(Rect,Rect.Right - aCanvas.TextWidth('Minimum') - 4, Rect.Top + 2, 'Minimum');
                if aMaximumRow then
                  aCanvas.TextRect(Rect,Rect.Right - aCanvas.TextWidth('Maximum') - 4, Rect.Top + 2, 'Maximum');
              end;
        end;

      if ACol < sgGrid.FixedCols then {Finish the grid lines}
        begin
          aCanvas.Pen.Color := clWindowText;

          if aCol = (sgGrid.FixedCols - 1) then
            begin
              aCanvas.MoveTo(Rect.Right - 1, Rect.Top);
              aCanvas.LineTo(Rect.Right - 1, Rect.Bottom);
            end;

          if (ARow >= (sgGrid.FixedRows - 1)) and (aRow < (sgGrid.RowCount - 1)) then
            begin
              aCanvas.MoveTo(Rect.Left, Rect.Bottom - 1);
              aCanvas.LineTo(Rect.Right, Rect.Bottom - 1);
            end;
        end
      else if aRow < sgGrid.FixedRows then
        begin
          if aRow = (sgGrid.FixedRows - 1) then
            begin
              aCanvas.MoveTo(Rect.Left, Rect.Bottom - 1);
              aCanvas.LineTo(Rect.Right, Rect.Bottom - 1);
            end;
          aCanvas.MoveTo(Rect.Right - 1, Rect.Top);
          aCanvas.LineTo(Rect.Right - 1, Rect.Bottom);
        end
    end
  else {Data cells}
    begin
      {Alternating row colors}
      if frac((ARow - sgGrid.FixedRows) / 2) > 0 then
        fDisplayColor := cl3DLight
      else
        fDisplayColor := clWindow;

      aCanvas.Font.Color := clWindowText;

      aCanvas.Brush.Color := fDisplayColor;
      aCanvas.FillRect(Rect);

      aCanvas.Pen.Color := cl3DLight;
      aCanvas.MoveTo(Rect.Right - 1, Rect.Top);
      aCanvas.LineTo(Rect.Right - 1, Rect.Bottom);

      if gdSelected in State then
        begin
          aCanvas.Pen.Color := clWindowText;
          aCanvas.Pen.Width := 1;

          {Draw the top side as selected}
          if (sgGrid.Selection.Top = ARow) and (sgGrid.Selection.Left <= aCol) and (sgGrid.Selection.Right >= aCol) then
            begin
              aCanvas.MoveTo(Rect.Left, Rect.Top);
              aCanvas.LineTo(Rect.Right, Rect.Top);
            end;

          {Draw the bottom side as selected}
          if (sgGrid.Selection.Bottom = ARow) and (sgGrid.Selection.Left <= aCol) and (sgGrid.Selection.Right >= aCol) then
            begin
              aCanvas.MoveTo(Rect.Left, Rect.Bottom - 1);
              aCanvas.LineTo(Rect.Right, Rect.Bottom - 1);
            end;

          {Draw the left side as selected}
          if (sgGrid.Selection.Left = ACol) and (sgGrid.Selection.Top <= aRow) and (sgGrid.Selection.Bottom >= aRow) then
            begin
              aCanvas.MoveTo(Rect.Left, Rect.Top);
              aCanvas.LineTo(Rect.Left, Rect.Bottom);
            end;

          {Draw the right side as selected}
          if (sgGrid.Selection.Right = ACol) and (sgGrid.Selection.Top <= aRow) and (sgGrid.Selection.Bottom >= aRow) then
            begin
              aCanvas.MoveTo(Rect.Right - 1, Rect.Top);
              aCanvas.LineTo(Rect.Right - 1, Rect.Bottom);
            end;
          aCanvas.Pen.Width := 1;
        end;

      aCanvas.Font.Style := [];

      if sgGrid.Objects[ACol, ARow] <> nil then
        with TInterfaceList(sgGrid.Objects[ACol, ARow]) do
          begin
            for i := 0 to Count - 1 do
              if Items[i].QueryInterface(IGridItem, aGridItem) = 0 then
                begin
                  aTimeRect := Types.Rect(
                    Rect.Left + 3,
                    Rect.Top + (i * sgGrid.DefaultRowHeight) + 1,
                    Rect.Left + aCanvas.TextWidth('00:00 '),
                    Rect.Top + (i * sgGrid.DefaultRowHeight) + 1 + aCanvas.TextHeight('|') + 1);

                  aCanvas.Rectangle(aTimeRect);

                  aDataRect := Types.Rect(
                    aTimeRect.Right + 2,
                    Rect.Top + (i * sgGrid.DefaultRowHeight) + 1,
                    Rect.Right - 1,
                    Rect.Top + (i * sgGrid.DefaultRowHeight) + 1 + aCanvas.TextHeight('|') + 1);

                  aCanvas.Rectangle(aDataRect);

                  {Normal font for the time display}
                  aCanvas.Font.Style := [];
                  aCanvas.Font.Color := clWindowText;
                  aCanvas.TextRect(aTimeRect, aTimeRect.Left, aTimeRect.Top, FormatDateTime('hh:mm', aGridItem.getDateTime));

                  {
                   Before we get the font, we have to zorch out fDisplayFont, as
                   it will have a habit of keeping things like colors from grid
                   item to grid item unless they're overwritten.
                  }

                  fDisplayFont.Color := clWindowText;
                  fDisplayFont.Style := [];


                  {Now get the font for the item}
                  fOnGridGetItemFont(aGridItem, fDisplayFont);
                  aCanvas.Font.Assign(fDisplayFont);

                  aValue := ' ' + aGridItem.getDisplayValue;

                  aTextFlag := fOnGridGetItemFlag(aGridItem);
                  if aTextFlag = gfNone then
                    aTextWidth := (aDataRect.Right - aDataRect.Left - 4)
                  else
                    aTextWidth := (aDataRect.Right - aDataRect.Left - 16);

                  if aCanvas.TextWidth(aValue) > aTextWidth then
                    begin
                      while (aCanvas.TextWidth(Format('%s ...', [aValue])) > aTextWidth) and (Length(aValue)>0) do
                        aValue := Copy(aValue, 1, Length(aValue) - 1);
                      aValue := Format('%s ...', [aValue]);
                    end;

                  if (HighlightedCell.X = aCol) and (HighlightedCell.Y = aRow) and (i = HighlightedItem) then
                    begin
                      aCanvas.Font.Style := aCanvas.Font.Style + [fsUnderline];
                      aCanvas.Font.Color := clHotLight;
                    end
                  else
                    aCanvas.Font.Assign(fDisplayFont);

                  {
                    zorch out fDisplayColor.
                  }

                  fDisplayColor := clWindowText;

                  if fOnGridGetItemColor(aGridItem, fDisplayColor) then
                    aCanvas.Brush.Color := fDisplayColor;

                  aCanvas.FillRect(aDataRect);
                  aCanvas.TextRect(aDataRect, aDataRect.Left, aDataRect.Top, aValue);
                  aCanvas.Font.Style := aCanvas.Font.Style - [fsBold];
                  aCanvas.Font.Style := aCanvas.Font.Style - [fsUnderline];
                  aCanvas.Font.Color := clWindowText;
                  aCanvas.Font.Style := aCanvas.Font.Style - [fsUnderline];

                  {Attempt to draw an image on the cell}
                  case aTextFlag of
                    gfInfo: frmImageList.ilApplicationImages16.Draw(aCanvas, aDataRect.Right - 13, aDataRect.Top + 2, INFO, True);
                  end;

                  if frac((ARow - sgGrid.FixedRows) / 2) > 0 then
                    aCanvas.Brush.Color := cl3DLight
                  else
                    aCanvas.Brush.Color := clWindow;
                end;

            {***********************************************************************************************}
            {***********************************************************************************************}
            {***********************************************************************************************}
            {***********************************************************************************************}
            {***********************************************************************************************}
            {***********************************************************************************************}

            {Check for in cell totals}
            if (Self.fGridStyle = gsDateTimeList) then
              if fTermList.Count > 0 then
                begin
                  {Need to get the term we are working with}
                  fTermList[aCol - sgGrid.FixedCols].QueryInterface(IGridTerm, aGridTerm);
                  if aGridTerm.getDisplayInCellTotal then
                    begin
                      {Need a new IInterface list since the grid holds an actual TInterfaceList}
                      TInterfaceList.Create.GetInterface(IInterfaceList, aItemList);
                      with TInterfaceList(sgGrid.Objects[ACol, ARow]) do
                        for i := 0 to Count - 1 do
                          aItemList.Add(Items[i]);

                      aTotal := fOnGridFetchTotal(aItemList, aGridTerm);

                      aTotalRect := Types.Rect(
                        Rect.Left + 3,
                        Rect.Bottom - sgGrid.DefaultRowHeight + 2,
                        Rect.Right - 1,
                        Rect.Bottom - 1);

                      aCanvas.Font.Style := [fsBold];

                      aCanvas.TextRect(
                        aTotalRect,
                        aTotalRect.Right - aCanvas.TextWidth(aTotal) - 1,
                        aTotalRect.Top,
                        aTotal);
                      aCanvas.Pen.Color := cl3DDkShadow;
                      aCanvas.MoveTo(aTotalRect.Left, aTotalRect.Top);
                      aCanvas.LineTo(aTotalRect.Right - 3, aTotalRect.Top);
                      aItemList.Clear; {Relase these interfaces}
                    end;
                end;
          end
      else if aTotalRow or aCountRow or aAverageRow or aMaximumRow or aMinimumRow then
        begin
          if fTermList.Count > 0 then
            fTermList[aCol - sgGrid.FixedCols].QueryInterface(IGridTerm, aGridTerm)
          else
            Exit;

          {Build a list with every item in the column in it first}
          aItemList := TInterfaceList.Create;
          for r := 0 to sgGrid.RowCount - 1 do
            if sgGrid.Objects[aCol, r] <> nil then
              with TInterfaceList(sgGrid.Objects[aCol, r]) do
                for i := 0 to Count - 1 do
                  aItemList.Add(Items[i]);

          {Get the total}
          aTotal := fOnGridFetchTotal(aItemList, aGridTerm);

          {Get the count}
          aCount := fOnGridFetchCount(aItemList, aGridTerm);

          {Get the average}
          aAverage := fOnGridFetchAverage(aItemList, aGridTerm);

          {Get the minimum}
          aMinimum := fOnGridFetchMinValue(aItemList, aGridTerm);

          {Get the maximum}
          aMaximum := fOnGridFetchMaxValue(aItemList, aGridTerm);

          aCanvas.Font.Style := aCanvas.Font.Style + [fsBold];

          if aTotalRow and aGridTerm.getDisplayTotal then
            aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth(aTotal), Rect.Top + 2, aTotal);

          if aCountRow and aGridTerm.getDisplayCount then
            aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth(IntToStr(aCount)), Rect.Top + 2, IntToStr(aCount));

          if aAverageRow and aGridTerm.getDisplayAverage then
            if aCount > 0 then
              aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth(aAverage), Rect.Top + 2, aAverage)
            else
              aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth('***'), Rect.Top + 2, '***');

          if aMinimumRow and aGridTerm.getDisplayMinValue then
            if aCount > 0 then
              aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth(aMinimum), Rect.Top + 2, aMinimum)
            else
              aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth('***'), Rect.Top + 2, '***');

          if aMaximumRow and aGridTerm.getDisplayMaxValue then
            if aCount > 0 then
              aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth(aMaximum), Rect.Top + 2, aMaximum)
            else
              aCanvas.TextOut(Rect.Right - 2 - aCanvas.TextWidth('***'), Rect.Top + 2, '***');

          aCanvas.Font.Style := aCanvas.Font.Style - [fsBold];

          aItemList.Clear; {gotta clear it to release the individual interfaces}
        end;
    end;
end;

procedure TfraGridFrame.acDisplayResizeExecute(Sender: TObject);
begin
  if fUpdating then
    Exit;

  ClearAllGridObjects; {In case this wasn't called after gridstyle change}

  BuildTimeSlots;

  cbxInterval.ItemIndex := Ord(fGridInterval);
  if fGridStyle = gsTerminologyList then
    begin
      if fTermList.Count > 0 then
        sgGrid.RowCount := 2 + fTermList.Count
      else
        sgGrid.RowCount := 3; {Minimum value with 2 fixed rows}

      if fDateList.Count > 0 then
        sgGrid.ColCount := 1 + fDateList.Count
      else
        sgGrid.ColCount := 2; {Minimum value with 1 fixed cols}

      sgGrid.FixedCols := 1;

      if ScreenReaderSystemActive then
        sgGrid.FixedRows := 1
      else
        sgGrid.FixedRows := 2;
    end
  else
    begin
      if fTermList.Count > 0 then
        sgGrid.ColCount := 2 + fTermList.Count
      else
        sgGrid.ColCount := 3; {Minimum with 1 fixed column}

      if fDateList.Count > 0 then
        sgGrid.RowCount := 1 + fDateList.Count
      else
        sgGrid.RowCount := 2;

      {Cleanup duties}
      if ScreenReaderSystemActive then
        sgGrid.FixedCols := 1
      else
        sgGrid.FixedCols := 2;
      sgGrid.FixedRows := 1;
    end;

  if fGridStyle = gsDateTimeList then
    begin
      if fTotalsRow then
        sgGrid.RowCount := sgGrid.RowCount + 1;

      if fCountsRow then
        sgGrid.RowCount := sgGrid.RowCount + 1;

      if fAveragesRow then
        sgGrid.RowCount := sgGrid.RowCount + 1;

      if fMinValueRow then
        sgGrid.RowCount := sgGrid.RowCount + 1;

      if fMaxValueRow then
        sgGrid.RowCount := sgGrid.RowCount + 1;
    end;

  acRefreshGridData.Execute; {Move the data's to their new cells}
  acRefreshDisplay.Execute;
end;

procedure TfraGridFrame.acExpandCollapseExecute(Sender: TObject);
begin
  Expanded := not Expanded; {This drives us to the proper method}
end;

procedure TfraGridFrame.acPivotExecute(Sender: TObject);
begin
  {acResize is called in the setGridStyle method}
  if fGridStyle = gsTerminologyList then
    setGridStyle(gsDateTimeList)
  else
    setGridStyle(gsTerminologyList);
end;

procedure TfraGridFrame.acSetIntervalExecute(Sender: TObject);
begin
  setInterval(GRID_INTERVAL_VALUE[TGridInterval(cbxInterval.ItemIndex)]);
end;

procedure TfraGridFrame.acRefreshExecute(Sender: TObject);
begin
  ClearAllGridObjects; {Clears everything out of the grid}
  LoadNewDataSet; {Reloads the data list with new data}
  acRefreshGridData.Execute; {Places the list of data into the proper cells}
  acRefreshDisplay.Execute; {Refreshes the picture}
end;

procedure TfraGridFrame.acRefreshDisplayExecute(Sender: TObject);
var
  GridHeight: integer;
  r, c, h: integer;
  aRect: TRect;
  aInCellTotal: boolean;
  aGridTerm: IGridTerm;
begin
  if fUpdating then
    Exit; {Called BeginUpdate - ignore this stuff for now}

  {Do we get to see the grid????}
  sgGrid.Visible := fExpanded;

  if fExpanded then
    begin
      {Reset Row Heights (r) based on cell with most items in that row}
      for r := sgGrid.FixedRows to sgGrid.RowCount - 1 do
        begin
          h := sgGrid.DefaultRowHeight; {Starting point :)}
          for c := sgGrid.FixedCols to sgGrid.ColCount - 1 do
            begin
              {Ok, are we in gsDateTimeList and does this term have an in cell total to display}
              aInCellTotal := False; {Start with a default}
              if (fGridStyle = gsDateTimeList) then
                if fTermList[c - sgGrid.FixedCols].QueryInterface(IGridTerm, aGridTerm) = 0 then
                  aInCellTotal := aGridTerm.getDisplayInCellTotal;

              if sgGrid.Objects[c, r] <> nil then {This will be the TInterfaceList item}
                if h < (sgGrid.DefaultRowHeight * (TInterfaceList(sgGrid.Objects[c, r]).Count + BOOL2INT[aInCellTotal])) then
                  h := sgGrid.DefaultRowHeight * (TInterfaceList(sgGrid.Objects[c, r]).Count + BOOL2INT[aInCellTotal]);
            end;
          sgGrid.RowHeights[r] := h;
        end;

      {Now calculate the entire grid height as a sum of all row heights and gridline widths}
      GridHeight := 0;
      for r := 0 to sgGrid.RowCount - 1 do
        inc(GridHeight, sgGrid.RowHeights[r] + sgGrid.GridLineWidth);

      Inc(GridHeight, 2);

      {Now set the stringgrid to the new height}
      sgGrid.Height := GridHeight;
      {Now set this frame to the appropriate height}
      Height := sgGrid.Top + sgGrid.Height + 16; {Woo Hoo!!!!}
    end
  else {It's collapsed, just set it to the height of the header panel}
    Height := pnlViewHeader.Height + 16;

  {Now draw the plus.minus image cause it's pretty}
  aRect := imgPlusMinus.ClientRect;
  imgPlusMinus.Canvas.Pen.Color := cl3DDkShadow;
  imgPlusMinus.Canvas.Rectangle(aRect);
  imgPlusMinus.Canvas.MoveTo(aRect.Left + 2, aRect.Top + 4);
  imgPlusMinus.Canvas.LineTo(aRect.Left + 7, aRect.Top + 4);

  if not fExpanded then {Turn that minus into a plus}
    begin
      imgPlusMinus.Canvas.MoveTo(aRect.Left + 4, aRect.Top + 2);
      imgPlusMinus.Canvas.LineTo(aRect.Left + 4, aRect.Top + 7);
    end;

  pnlToolbar.Visible := fExpanded;

  sgGrid.Invalidate;
end;

procedure TfraGridFrame.acRefreshGridDataExecute(Sender: TObject);
var
  i, j, r, c: integer;
  aGridItem: IGridItem;
  aGridTerm: IGridTerm;
  aObservation: IObservation;
  aGridDateTime: IGridDateTime;
  aGridIndexTerm: integer;
  aGridIndexDateTime: integer;
  ObsInfo: string;
  //
  AItemList: IInterfaceList;
  //
  aTotal,
  aAverage,
  aMinimum,
  aMaximum,
  aCount: string;
  //
  aTotalsRow,
  aAveragesRow,
  aMinimumsRow,
  aMaximumsRow,
  aCountsRow: Integer;
  k: Integer;
begin
  ClearAllGridObjects;

  {DeLinting}
  aTotalsRow := 0;
  aAveragesRow := 0;
  aMinimumsRow := 0;
  aMaximumsRow := 0;
  aCountsRow := 0;

  {Load the data into the sgGrid.Objects[]}
  for i := 0 to fItemList.Count - 1 do
    if fItemList[i].QueryInterface(IGridItem, aGridItem) = 0 then
    begin
      for j := 0 to fTermList.Count - 1 do
      begin
        if fTermList[j].QueryInterface(IGridTerm, aGridTerm) = 0 then
          if fOnGridIsItemInTerm(aGridItem, aGridTerm) then
            begin
              aGridIndexTerm := j;
              aGridIndexDateTime := fGridFindDateIndex(aGridItem);

              if (aGridIndexTerm > -1) and (aGridIndexDateTime > -1) then
                begin
                  if ScreenReaderSystemActive then
                  begin
                    if fGridStyle = gsTerminologyList then
                      begin
                        r := aGridIndexTerm + sgGrid.FixedRows;
                        c := aGridIndexDateTime + sgGrid.FixedCols;
                      end
                    else
                      begin
                        r := aGridIndexDateTime + sgGrid.FixedRows;
                        c := aGridIndexTerm + sgGrid.FixedCols;
                      end;

                    ObsInfo := '';
                    // Get the observation info.
                    if fItemList[i].QueryInterface(IObservation, aObservation) = 0 then
                    begin
                      case aObservation.getStatus of
                      osUnverified: ObsInfo := ' unverified ';
                      osVerified: ObsInfo := ' verified ';
                      osArchived: ObsInfo := ' archived ';
                      osPurged: ObsInfo := ' purged ';
                      osCorrected: ObsInfo := ' corrected ';
                      osRescinded: ObsInfo := ' rescinded ';
                      end;

                    end;

                    // Get the status.
                    if Assigned(fOnGridGetItemFlag) then
                      case fOnGridGetItemFlag(aGridItem) of
                        gfInfo: ObsInfo := ObsInfo + ' with information ';
                      end;
                    if sgGrid.Cells[c, r] = '' then
                      sgGrid.Cells[c, r] := sgGrid.Cells[c, r] + ' ' +
                        FormatDateTime('(hh:nn)', aGridItem.getDateTime) + aGridItem.getDisplayValue + ObsInfo
                    else
                      sgGrid.Cells[c, r] := sgGrid.Cells[c, r] + ', ' +
                        FormatDateTime('(hh:nn)', aGridItem.getDateTime) + aGridItem.getDisplayValue + ObsInfo;
                    if sgGrid.Objects[c, r] = nil then
                      sgGrid.Objects[c, r] := TInterfaceList.Create;
                    TInterfaceList(sgGrid.Objects[c, r]).Add(fItemList[i]);
                  end
                  else
                  begin
                    if fGridStyle = gsTerminologyList then
                      begin
                        r := aGridIndexTerm + sgGrid.FixedRows;
                        c := aGridIndexDateTime + sgGrid.FixedCols;
                      end
                    else
                      begin
                        r := aGridIndexDateTime + sgGrid.FixedRows;
                        c := aGridIndexTerm + sgGrid.FixedCols;
                      end;

                    if sgGrid.Objects[c, r] = nil then
                      sgGrid.Objects[c, r] := TInterfaceList.Create;
                    TInterfaceList(sgGrid.Objects[c, r]).Add(fItemList[i]);
                  end;
                end
              else
                {It doesn't particular grid};
            end;
      end;
    end;

  // Now for the column and row headers.
  if ScreenReaderSystemActive then
  begin
    if fGridStyle = gsTerminologyList then
    begin
      sgGrid.RowCount := fTermList.Count + 1;
      sgGrid.ColCount := fDateList.Count + 1;
    end
    else
    begin
      sgGrid.RowCount := fDateList.Count + 1;
      sgGrid.ColCount := fTermList.Count + 1;
      //Add extra rows for totals and stuff
      if fTotalsRow then
      begin
        aTotalsRow := sgGrid.RowCount + 1;
        sgGrid.RowCount := aTotalsRow;
        sgGrid.Cells[0, aTotalsRow] := 'Total';
      end;
      if fCountsRow then
      begin
        aCountsRow := sgGrid.RowCount + 1;
        sgGrid.RowCount := aCountsRow;
        sgGrid.Cells[0, aCountsRow] := 'Count';
      end;
      if fAveragesRow then
      begin
        aAveragesRow := sgGrid.RowCount + 1;
        sgGrid.RowCount := aAveragesRow;
        sgGrid.Cells[0, aAveragesRow] := 'Average';
      end;
      if fMinValueRow then
      begin
        aMinimumsRow := sgGrid.RowCount + 1;
        sgGrid.RowCount := aMinimumsRow;
        sgGrid.Cells[0, aMinimumsRow] := 'Minimum';
      end;
      if fMaxValueRow then
      begin
        aMaximumsRow := sgGrid.RowCount + 1;
        sgGrid.RowCount := aMaximumsRow;
        sgGrid.Cells[0, aMaximumsRow] := 'Maximum';
      end;
    end;


    TInterfaceList.Create.GetInterface(IInterfaceList, AItemList);
    try
      for I := 0 to fTermList.Count - 1 do
      begin
        AItemList.Clear;
        if fTermList[I].QueryInterface(IGridTerm, aGridTerm) = 0 then
        begin
          if fGridStyle = gsTerminologyList then
          begin
            sgGrid.Cells[0, I + 1] := aGridTerm.getDisplayName;
          end
          else
          begin
            //fGridStyle = gsDateTimeList;
            sgGrid.Cells[I + 1, 0] := aGridTerm.getDisplayName;
            if fTermList[I].QueryInterface(IGridTerm, aGridTerm) = 0 then
            begin

              for J := 0 to sgGrid.RowCount - 1 do
              begin
                if assigned(sgGrid.Objects[I + 1, J]) then
                begin
                  for k := 0 to TInterfaceList(sgGrid.Objects[I + 1, J]).Count - 1 do
                    AItemList.Add(TInterfaceList(sgGrid.Objects[I + 1, J])[K]);
                end;
              end;

              if aGridTerm.getDisplayTotal and fTotalsRow then
              begin
                aTotal := fOnGridFetchTotal(AItemList, aGridTerm);
                sgGrid.Cells[I + 1, aTotalsRow] := aTotal;
              end;

              if fCountsRow then
              begin
                {Get the count}
                aCount := IntToStr(fOnGridFetchCount(AItemList, aGridTerm));
                sgGrid.Cells[I + 1, aCountsRow] := aCount;
              end;

              if fAveragesRow then
              begin
                {Get the average}
                aAverage := fOnGridFetchAverage(AItemList, aGridTerm);
                sgGrid.Cells[I + 1, aAveragesRow] := aAverage;
              end;

              if fMinValueRow then
              begin
                {Get the minimum}
                aMinimum := fOnGridFetchMinValue(AItemList, aGridTerm);
                sgGrid.Cells[I + 1, aMinimumsRow] := aMinimum;
              end;

              if fMaxValueRow then
              begin
                {Get the maximum}
                aMaximum := fOnGridFetchMaxValue(AItemList, aGridTerm);
                sgGrid.Cells[I + 1, aMaximumsRow] := aMaximum;
              end;
            end;
          end;
        end;
      end;
    finally
      AItemList.Clear;
      AItemList := nil;
    end;

    for I := 0 to fDateList.Count - 1 do
    begin
      if fDateList[I].QueryInterface(IGridDateTime, aGridDateTime) = 0 then
      begin
        if fGridStyle = gsTerminologyList then
        begin
          sgGrid.Cells[I + 1, 0] := FormatDateTime('mmmm dd yyyy', aGridDateTime.DateTime) + ' ' + aGridDateTime.getTime;
        end
        else
        begin
          sgGrid.Cells[0, I + 1] := FormatDateTime('mmmm dd yyyy', aGridDateTime.DateTime) + ' ' + aGridDateTime.getTime;
        end;
      end;
    end;

    // Now to put the totals and stuff on the screen;
    if fTotalsRow then
    begin
      sgGrid.RowCount := sgGrid.RowCount + 1;
      sgGrid.Cells[0, sgGrid.RowCount] := 'Total';

    end;
  end;
  acRefreshDisplay.Execute;
end;

procedure TfraGridFrame.acInsertExecute(Sender: TObject);
begin
  if Assigned(fOnGridInsertData) then
    fOnGridInsertData(fInterface)
  else
    ShowMessage('Unable to insert row');
end;

procedure TfraGridFrame.sgGridMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
const
  NO_OBSERVATION = '                    No observation selected';
  OBSERVATION = '                    Observation - (%s) %s: %s';
var
  c, r: integer;
  ItemCount: integer;
  MouseSlot: integer;
  Rect: TRect;
  aGridItem: IGridItem;
  ItemList: TInterfaceList;
  Status: string;
  Comment: string;
begin

  sgGrid.MouseToCell(X, Y, c, r);
  if (c < 0) or (r < 0) then {Not over a cell}
    begin
      sgGrid.Cursor := crDefault;
      sbObservationComments.SimpleText := NO_OBSERVATION;
      sgGrid.Invalidate;
      Exit;
    end;

  if not Assigned(fOnGridClickItem) then {No click method, no highlighting}
    begin
      sgGrid.Cursor := crDefault;
      sbObservationComments.SimpleText := NO_OBSERVATION;
      sgGrid.Invalidate;
      Exit;
    end;

  Rect := sgGrid.CellRect(c, r);
  if (sgGrid.Objects[c, r] <> nil) and (X > (Rect.Left + sgGrid.Canvas.TextWidth('00:00 '))) then
    begin

      ItemList := TInterfaceList(sgGrid.Objects[c,r]);
      ItemCount := ItemList.Count;
      MouseSlot := trunc((Y - Rect.Top) / sgGrid.DefaultRowHeight);
      if MouseSlot < ItemCount then {We have something to highlight}
        if (HighLightedCell.X <> c) or (HighlightedCell.Y <> r) then
          begin
            HighlightedCell.X := c;
            HighlightedCell.Y := r;
            HighlightedItem := MouseSlot;
            sgGrid.Cursor := crHandPoint;
            //
            if ItemList[MouseSlot].QueryInterface(IGridItem, aGridItem) = 0 then
            begin
              Comment := aGridItem.getComment;
              if Comment = '' then
                Comment := '<No Comment Entered>';

              Status := format(OBSERVATION, [FormatDateTime('mm/dd/yyyy hh:nn:ss', aGridItem.getDateTime),
                          aGridItem.getDisplayValue, Comment]);
              sbObservationComments.SimpleText  := Status;
            end;

            //
            sgGrid.Invalidate;
          end
        else
          begin
            if HighlightedItem <> MouseSlot then
              begin
                HighLightedItem := MouseSlot;
                sgGrid.Cursor := crHandPoint;
                if ItemList[MouseSlot].QueryInterface(IGridItem, aGridItem) = 0 then
                begin
                  Comment := aGridItem.getComment;
                  if Comment = '' then
                    Comment := '<No Comment Entered>';

                  Status := format(OBSERVATION, [FormatDateTime('mm/dd/yyyy hh:nn:ss', aGridItem.getDateTime),
                              aGridItem.getDisplayValue, Comment]);
                  sbObservationComments.SimpleText  := Status;
                end;

                sgGrid.Invalidate;
              end
          end
      else if HighlightedItem > -1 then
        begin
          HighlightedCell.X := -1;
          HighlightedCell.Y := -1;
          HighlightedItem := -1;
          sbObservationComments.SimpleText := NO_OBSERVATION;
          sgGrid.Invalidate;
        end;
    end
  else if HighlightedItem > -1 then
    begin
      HighlightedCell.X := -1;
      HighlightedCell.Y := -1;
      HighlightedItem := -1;
      sgGrid.Cursor := crDefault;
      sbObservationComments.SimpleText := NO_OBSERVATION;
      sgGrid.Invalidate;
    end;

  if (c >= sgGrid.Selection.Left) and (c <= sgGrid.Selection.Right) and
    (r >= sgGrid.Selection.Top) and (r <= sgGrid.Selection.Bottom) then
  begin
    sbObservationComments.SimpleText := NO_OBSERVATION;
    sgGrid.Invalidate;
  end;
end;

procedure TfraGridFrame.sgGridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  c, r,
  i: integer;
  Rect: TRect;
  ItemCount: integer;
  MouseSlot: integer;
  aGridItem: IGridItem;
begin
  if not Assigned(fOnGridClickItem) then {No click method, no worry}
    Exit;

  {
  Note, you shouldn't be clicking a mouse if you're using the screen reader.  But,
    just in case you are...
  }
  if ScreenReaderSystemActive then
    exit;

  fSelectedItems.Clear;

  sgGrid.MouseToCell(X, Y, c, r);
  if (c < 0) or (r < 0) then
    Exit; {Not over a cell}

  if sgGrid.Objects[c, r] <> nil then
    begin
      Rect := sgGrid.CellRect(c, r);
      ItemCount := TInterfaceList(sgGrid.Objects[c, r]).Count;
      for I := 0 to ItemCount - 1 do
      begin
        aGridItem := IGridItem(TInterfaceList(sgGrid.Objects[c, r])[I]);
        fSelectedItems.Add(aGridItem);
      end;
      MouseSlot := trunc((Y - Rect.Top) / sgGrid.DefaultRowHeight);
      if MouseSlot < ItemCount then {We have something clicked on here is it highlighted}
        if (HighLightedCell.X = c) and (HighlightedCell.Y = r) and (HighlightedItem = MouseSlot) then
          if TInterfaceList(sgGrid.Objects[c, r])[MouseSlot].QueryInterface(IGridItem, aGridItem) = 0 then
            begin
              HighlightedCell.X := -1;
              HighlightedCell.Y := -1;
              HighlightedItem := -1;
              sgGrid.Invalidate;
              fOnGridClickItem(aGridItem);
            end;
    end;
end;

procedure TfraGridFrame.ClearData;
begin
  fItemList.Clear;
  ClearAllGridObjects;
  acRefreshDisplay.Execute;
  sgGrid.Invalidate;
end;

procedure TfraGridFrame.sgGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
var
  I: Integer;
  c,
  r: Integer;
begin
  CanSelect := ((ACol - sgGrid.LeftCol) < sgGrid.VisibleColCount); {Col is not fully viewable}
  if not CanSelect then
    exit;

  if (ACol < sgGrid.FixedCols) or (ARow < sgGrid.FixedRows) then
    exit;

  fSelectedItems.Clear;

  r := aRow; // + sgGrid.FixedRows;
  c := aCol; // + sgGrid.FixedCols;
  if Assigned(sgGrid.Objects[c, r]) then
  begin
    for I := 0 to TInterfaceList(sgGrid.Objects[c, r]).Count - 1 do
    begin
      fSelectedItems.Add(TInterfaceList(sgGrid.Objects[c, r])[I]);
    end;
  end;
end;

procedure TfraGridFrame.sgGridTopLeftChanged(Sender: TObject);
begin
  if fLocked and (not fSynchronizing) then
    if Assigned(fOnGridSynchNeeded) then
      fOnGridSynchNeeded(Self as IGridFrame, sgGrid.TopRow, sgGrid.LeftCol);
end;

procedure TfraGridFrame.SynchGrid(aMasterGrid: IInterface; aTopRow, aLeftCol: integer);
var
  aGridFrame: IGridFrame;
begin
  try
    fSynchronizing := True;
    if aMasterGrid.QueryInterface(IGridFrame, aGridFrame) = 0 then
      if aGridFrame.getID <> self.getID then
        if fGridStyle = gsTerminologyList then
          sgGrid.LeftCol := aLeftCol;
  finally
    fSynchronizing := False;
    acRefreshDisplay.Execute;
  end;
end;

procedure TfraGridFrame.FrameResize(Sender: TObject);
begin
  sgGrid.Invalidate;
  acCheckEdgeBorder.Execute;
end;

procedure TfraGridFrame.acNextPageExecute(Sender: TObject);
begin
  if sgGrid.LeftCol < (sgGrid.ColCount - 1) then
    begin
      sgGrid.LeftCol := sgGrid.LeftCol + 1;
      sgGrid.Invalidate;
    end;
end;

procedure TfraGridFrame.acPrevPageExecute(Sender: TObject);
begin
  if sgGrid.LeftCol > sgGrid.FixedCols then
    begin
      sgGrid.LeftCol := sgGrid.LeftCol - 1;
      sgGrid.Invalidate;
    end;
end;

procedure TfraGridFrame.acPrintExecute(Sender: TObject);
begin
  if Assigned(fOnGridPrintData) then
    fOnGridPrintData(fInterface)
  else
    MessageDlg('No print method has been defined.', mtError, [mbOK], 0);
end;

procedure TfraGridFrame.acSettingsExecute(Sender: TObject);
begin
  if Assigned(fOnGridProperties) then
    fOnGridProperties(fInterface)
  else
    MessageDlg('No properties method has been assigned.', mtError, [mbOk], 0);
end;

function TfraGridFrame.getExpanded: boolean;
begin
  Result := fExpanded;
end;

function TfraGridFrame.getForm: TForm;
begin
  result := self;
end;

function TfraGridFrame.getHeight: integer;
begin
  Result := self.Height;
end;

function TfraGridFrame.getTermsOnXAxis: boolean;
begin
  Result := (fGridStyle = gsDateTimeList);
end;

function TfraGridFrame.getTitle: string;
begin
  Result := fTitle;
end;

procedure TfraGridFrame.IntervalItemClick(Sender: TObject);
var
  Item: TMenuItem;
  ItemIndex: Integer;
begin
  Item := FMenuItem.Find(DISPLAY_INTERVAL);

  ItemIndex := Item.IndexOf(TMenuItem(Sender));
  setInterval(GRID_INTERVAL_VALUE[TGridInterval(ItemIndex)]);
end;

function TfraGridFrame.getInCellTotals: boolean;
begin
  Result := fInCellTotals;
end;

function TfraGridFrame.getIncludeAverages: boolean;
begin
  Result := fAveragesRow;
end;

function TfraGridFrame.getIncludeCounts: boolean;
begin
  Result := fCountsRow;
end;

function TfraGridFrame.getIncludeMaxValue: boolean;
begin
  Result := fMaxValueRow;
end;

function TfraGridFrame.getIncludeMinValue: boolean;
begin
  Result := fMinValueRow;
end;

function TfraGridFrame.getIncludeTotals: boolean;
begin
  Result := fTotalsRow;
end;

function TfraGridFrame.getStartDate: TDateTime;
begin
  Result := fStartDate;
end;

function TfraGridFrame.getStopDate: TDateTime;
begin
  Result := fStopDate;
end;

function TfraGridFrame.GetSupplementalLabelString: string;
begin
  Result := '';

  if fSupplementalMethod <> '' then
    Result := Result + ' Method: ' + fSupplementalMethod;
  if fSupplementalPosition <> '' then
    Result := Result + ' | Position: ' + fSupplementalPosition;
  if fSupplementalLocation <> '' then
    Result := Result + ' | Location: ' + fSupplementalLocation;
  if fSupplementalProduct <> '' then
    Result := Result + ' | Product: ' + fSupplementalProduct;

  // We need to double check and make sure that we don't have a '|' as the first character.
  if Length(Result) > 3 then
    if Result[2] = '|' then
      Result := copy(Result,3, Length(Result));
end;

procedure TfraGridFrame.AddTermList(aInterfaceList: IInterfaceList);
var
  aGridTerm: IGridTerm;
  i: integer;
begin
  {Simpler if you already have a list of items}
  for i := 0 to aInterfaceList.Count - 1 do
    if aInterfaceList[i].QueryInterface(IGridTerm, aGridTerm) = 0 then
      AddTerm(aGridTerm);
end;

procedure TfraGridFrame.BeginUpdate;
begin
  fUpdating := True;
end;

procedure TfraGridFrame.ClearAllData;
begin
  ClearData;
end;

procedure TfraGridFrame.DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect);
begin
  sgGridDrawCell(Sender, ACol, aRow, Rect, []);
end;

procedure TfraGridFrame.EndUpdate;
begin
  fUpdating := False;
  setGridStyle(fGridStyle);
end;

function TfraGridFrame.FirstTerm: IGridTerm;
begin
  if fTermList.Count > 0 then
    fTermList.Items[0].QueryInterface(IGridTerm, Result)
  else
    Result := nil;
end;

procedure TfraGridFrame.FMenuItemClick(Sender: TObject);
begin
  if Parent is TScrollBox then
    TScrollBox(Parent).ScrollInView(self);
end;

function TfraGridFrame.getColCount: integer;
begin
  Result := sgGrid.ColCount;
end;

function TfraGridFrame.getColWidth(aCol: integer): integer;
begin
  try
    Result := sgGrid.ColWidths[aCol];
  except
    Result := -1;
  end;
end;

function TfraGridFrame.getGridClickTerm: TOnGridClickItem;
begin
  Result := fOnGridClickItem;
end;

function TfraGridFrame.getGridFetchData: TOnGridFetchData;
begin
  Result := fOnGridFetchData;
end;

function TfraGridFrame.getGridFetchMaxValue: TOnGridFetchMaxValue;
begin
  Result := fOnGridFetchMaxValue;
end;

function TfraGridFrame.getGridFetchMinValue: TOnGridFetchMinValue;
begin
  Result := fOnGridFetchMinValue;
end;

function TfraGridFrame.getGridFindTerm: TOnGridFindTerm;
begin
  Result := fOnGridFindTerm;
end;

function TfraGridFrame.getGridGetItemColor: TOnGridGetItemColor;
begin
  Result := fOnGridGetItemColor
end;

function TfraGridFrame.getGridGetItemFlag: TOnGridGetItemFlag;
begin
  Result := fOnGridGetItemFlag;
end;

function TfraGridFrame.getGridGetItemFont: TOnGridGetItemFont;
begin
  Result := fOnGridGetItemFont;
end;

function TfraGridFrame.getGridInsertData: TOnGridInsertData;
begin
  Result := fOnGridInsertData;
end;

function TfraGridFrame.getGridIsItemInTerm: TOnGridIsItemInTerm;
begin
  Result := fOnGridIsItemInTerm;
end;

function TfraGridFrame.getGridWidth: integer;
var
  i: integer;
begin
  Result := 0;
  for i := 0 to sgGrid.ColCount - 1 do
    Inc(Result, sgGrid.ColWidths[i]);
end;

function TfraGridFrame.getRowCount: integer;
begin
  Result := sgGrid.RowCount;
end;

function TfraGridFrame.getRowHeight(aRow: integer): integer;
begin
  try
    Result := sgGrid.RowHeights[aRow];
  except
    Result := -1;
  end;
end;

function TfraGridFrame.NextTerm(aGridTerm: IGridTerm): IGridTerm;
var
  i: integer;
begin
  i := fTermList.IndexOf(aGridTerm) + 1;
  if i < fTermList.Count then
    fTermList.Items[i].QueryInterface(IGridTerm, Result)
  else
    Result := nil;
end;

procedure TfraGridFrame.PmnClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := TMenuItem(Sender).Parent.IndexOf(TMenuItem(Sender));
  if (Index >= -1) and (Index < FSelectedItems.Count) then
  begin
    fOnGridClickItem(IGridItem(FSelectedItems[Index]));
  end;
end;

procedure TfraGridFrame.pmnPopup(Sender: TObject);
var
  I: Integer;
  Item: TMenuItem;
  GridItem: IGridItem;
begin
  {
  We need to figure out if we're in a cell right now, and, if we are, we need to try to
  figure out which one.  Then, we need to add the observations to the menu, so that they
  can be edited.
  }
  pmn.Items.Clear;

  for I := 0 to fSelectedItems.Count - 1 do
  begin
    fSelectedItems[I].QueryInterface(IGridItem, GridItem);
    Item := TMenuItem.Create(pmn);
    pmn.Items.Add(Item);
    Item.Caption := FormatDateTime('mmmm dd, yyyy hh:nn:ss', GridItem.getDateTime) + ' ' + GridItem.getDisplayValue;
    Item.OnClick := pmnClick; 
  end;
end;

procedure TfraGridFrame.setGridClickTerm(const Value: TOnGridClickItem);
begin
  fOnGridClickItem := Value;
end;

procedure TfraGridFrame.setGridFetchData(const Value: TOnGridFetchData);
begin
  fOnGridFetchData := Value;
end;

procedure TfraGridFrame.setGridFetchMaxValue(const Value: TOnGridFetchMaxValue);
begin
  fOnGridFetchMaxValue := Value;
end;

procedure TfraGridFrame.setGridFetchMinValue(const Value: TOnGridFetchMinValue);
begin
  fOnGridFetchMinValue := Value;
end;

procedure TfraGridFrame.setGridFindTerm(const Value: TOnGridFindTerm);
begin
  fOnGridFindTerm := Value;
end;

procedure TfraGridFrame.setGridGetItemColor(const Value: TOnGridGetItemColor);
begin
  fOnGridGetItemColor := Value;
end;

procedure TfraGridFrame.setGridGetItemFlag(const Value: TOnGridGetItemFlag);
begin
  fOnGridGetItemFlag := Value;
end;

procedure TfraGridFrame.setGridGetItemFont(const Value: TOnGridGetItemFont);
begin
  fOnGridGetItemFont := Value;
end;

procedure TfraGridFrame.setGridFetchCount(const Value: TOnGridFetchCount);
begin
  fOnGridFetchCount := Value;
end;

procedure TfraGridFrame.setGridInsertData(const Value: TOnGridInsertData);
begin
  fOnGridInsertData := Value;
  sbtnInsert.Enabled := Assigned(Value);
end;

procedure TfraGridFrame.setGridIsItemInTerm(const Value: TOnGridIsItemInTerm);
begin
  fOnGridIsItemInTerm := Value;
end;

procedure TfraGridFrame.setInCellTotals(const aValue: boolean);
begin
  fInCellTotals := aValue;
end;

procedure TfraGridFrame.setIncludeAverages(const Value: boolean);
begin
  fAveragesRow := Value;
end;

procedure TfraGridFrame.setIncludeCounts(const Value: boolean);
begin
  fCountsRow := Value;
end;

procedure TfraGridFrame.setIncludeMaxValue(const Value: boolean);
begin
  fMaxValueRow := Value;
end;

procedure TfraGridFrame.setIncludeMinValue(const Value: boolean);
begin
  fMinValueRow := Value;
end;

procedure TfraGridFrame.setIncludeTotals(const Value: boolean);
begin
  fTotalsRow := Value;
end;

procedure TfraGridFrame.setInsertCaption(const aValue: string; aHint: string);
begin
  sbtnInsert.Caption := aValue;
  sbtnInsert.Hint := aHint;
end;

procedure TfraGridFrame.setTermsOnXAxis(const Value: boolean);
begin
  if Value then
    setGridStyle(gsDateTimeList)
  else
    setGridStyle(gsTerminologyList);
end;

procedure TfraGridFrame.setTitle(const Value: string);
var
  aItem: TVA508AccessibilityItem;
begin
  {lblTitle needs to be wrappable and have ellipsis so the static one won't work}
  aItem := VA508AccessibilityManager1.AccessData.Add;
  aItem.AccessLabel := lblTitle;
  aItem.Component := pnlTitle;
  VA508AccessibilityManager1.RefreshComponents;
  fTitle := Value;
  lblTitle.Caption := Value;
  lblTitle.Hint := lblTitle.Caption;
  lblTitle.WordWrap := true;
  FMenuItem.Caption := Value;
end;

function TfraGridFrame.Term(index: integer): IGridTerm;
begin
  if index < fTermList.Count then
    fTermList[index].QueryInterface(IGridTerm, Result)
  else
    Result := nil;
end;

function TfraGridFrame.TermCount: integer;
begin
  Result := fTermList.Count;
end;

function TfraGridFrame.getAllowPivot: boolean;
begin
  Result := sbtnPivot.Visible;
end;

procedure TfraGridFrame.setAllowPivot(const Value: boolean);
begin
  acPivot.Enabled := Value;
end;

function TfraGridFrame.getGridFetchTotal: TOnGridFetchTotal;
begin
  Result := fOnGridFetchTotal;
end;

function TfraGridFrame.getGridFetchAverage: TOnGridFetchAverage;
begin
  Result := fOnGridFetchAverage;
end;

function TfraGridFrame.getGridFetchCount: TOnGridFetchCount;
begin
  Result := fOnGridFetchCount;
end;

procedure TfraGridFrame.setGridFetchAverage(const Value: TOnGridFetchAverage);
begin
  fOnGridFetchAverage := Value;
end;

procedure TfraGridFrame.setGridFetchTotal(const Value: TOnGridFetchTotal);
begin
  fOnGridFetchTotal := Value;
end;

function TfraGridFrame.getGridPrintData: TOnGridPrintData;
begin
  Result := fOnGridPrintData;
end;

function TfraGridFrame.getGridProperties: TOnGridProperties;
begin
  Result := fOnGridProperties;
end;

procedure TfraGridFrame.setGridPrintData(const Value: TOnGridPrintData);
begin
  // Historical or hysterical
end;

procedure TfraGridFrame.setGridProperties(const Value: TOnGridProperties);
begin
  fOnGridProperties := Value;
end;

function TfraGridFrame.fGridFetchAverage(aList: IInterfaceList; aTerm: IInterface): string;
var
  i: integer;
  t: Double;
  aGridItem: IGridItem;
begin
  t := 0;
  for i := 0 to aList.Count - 1 do
    if aList[i].QueryInterface(IGridItem, aGridItem) = 0 then
      t := t + aGridItem.getNumericValue;
  if aList.Count > 0 then
    Result := Format('%0.2f', [t / aList.Count])
  else
    Result := '0.00';
end;

function TfraGridFrame.fGridFetchCount(aList: IInterfaceList): integer;
begin
  Result := aList.Count;
end;

function TfraGridFrame.fGridFetchTotal(aList: IInterfaceList; aItem: IInterface): string;
var
  i: integer;
  t: Double;
  aGridItem: IGridItem;
begin
  t := 0;
  for i := 0 to aList.Count - 1 do
    if aList[i].QueryInterface(IGridItem, aGridItem) = 0 then
      t := t + aGridItem.getNumericValue;
  if aList.Count > 0 then
    Result := Format('%0.2f', [t])
  else
    Result := '0.00';
end;

function TfraGridFrame.getInterval: integer;
begin
  Result := GRID_INTERVAL_VALUE[fGridInterval];
end;

function TfraGridFrame.getMenu: TMenuItem;
begin
  result := FMenuItem;
end;

function TfraGridFrame.getID: string;
begin
  Result := fID;
end;

procedure TfraGridFrame.acRemoveExecute(Sender: TObject);
begin
  if Assigned(fOnGridClose) then
    fOnGridClose(fInterface);
end;

procedure TfraGridFrame.acCheckEdgeBorderExecute(Sender: TObject);
begin
  if fExpanded then
    begin
      {Now, are all the columns showing to the right??}
      (*
      lblTitle.Caption := Format(
        'LeftCol=%d  VisColCount=%d  sgGridColCount=%d',
        [sgGrid.LeftCol, sgGrid.VisibleColCount, sgGrid.ColCount]);
      *)
      //pnlRightBorder.Visible := ((sgGrid.LeftCol + sgGrid.VisibleColCount) <= (sgGrid.ColCount - 1));
    end;
end;

function TfraGridFrame.getInterface: IInterface;
begin
  Result := fInterface;
end;

end.

