unit oGridTerm;
{
================================================================================
*
*       Application:  Clinical Observations
*       Revision:     $Revision: 3 $  $Modtime: 5/02/08 11:35a $
*       Developer:    petit           
*       Site:         Hines OIFO
*
*       Description:  Default grid term object.
*
*       Notes:
*
*
================================================================================
*       $Archive: /CP Modernization/CliO/source/TGridFrame/oGridTerm.pas $
*
* $History: oGridTerm.pas $
 * 
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 5/14/08    Time: 12:30p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 3/08/08    Time: 9:56p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 11/10/07   Time: 12:59p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 3  *****************
 * User: Vhaishpetitd Date: 8/25/07    Time: 3:12p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 *
 * *****************  Version 2  *****************
 * User: Vhaishpetitd Date: 10/23/06   Time: 4:07p
 * Updated in $/CP Modernization/CliO/source/TGridFrame
 * Finished Pivots, Parser Key, and Totals.
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 10/05/06   Time: 1:01p
 * Created in $/CP Modernization/CliO/source/TGridFrame
 * Initial Check-In
 *
*
================================================================================
}
interface

uses
  Classes,
  iCliOGrid;

type
  TGridTerm = class(TInterfacedObject, IGridTerm)
  private
    fDisplayName: string;
    fDisplayWidth: integer;
    fDisplayTotal: boolean;
    fDisplayCount: boolean;
    fDisplayMinValue: boolean;
    fDisplayMaxValue: boolean;
    fDisplayAverage: boolean;
    fDisplayInCellTotal: boolean;
    function _AddRef: integer; stdcall;
    function _Release: integer; stdcall;
  public
    constructor Create(aDisplayName: string; aDisplayWidth: integer = 80);
    function getDisplayName: string; stdcall;
    function getDisplayWidth: integer; stdcall;
    function getDisplayTotal: boolean; stdcall;
    function getDisplayCount: boolean; stdcall;
    function getDisplayAverage: boolean; stdcall;
    function getDisplayMinValue: boolean; stdcall;
    function getDisplayMaxValue: boolean; stdcall;
    function getDisplayOnly: boolean; stdcall;
    function getDisplayInCellTotal: boolean; stdcall;
  end;

implementation

{ TGridTerm }

constructor TGridTerm.Create(aDisplayName: string; aDisplayWidth: integer = 80);
begin
  inherited Create;
  fDisplayName := aDisplayName;
  fDisplayWidth := aDisplayWidth;
  fDisplayTotal := True;
  fDisplayCount := True;
  fDisplayAverage := True;
  fDisplayInCellTotal := True;
  fDisplayMaxValue := True;
  fDisplayMinValue := True;
end;

function TGridTerm._AddRef: Integer;
begin
  Result := -1;
end;

function TGridTerm._Release: Integer;
begin
  Result := -1;
end;

function TGridTerm.getDisplayName: string;
begin
  Result := fDisplayName;
end;

function TGridTerm.getDisplayOnly: boolean;
begin
  Result := False;
end;

function TGridTerm.getDisplayWidth: integer;
begin
  Result := fDisplayWidth;
end;

function TGridTerm.getDisplayAverage: boolean;
begin
  Result := fDisplayAverage;
end;

function TGridTerm.getDisplayCount: boolean;
begin
  Result := fDisplayCount;
end;

function TGridTerm.getDisplayInCellTotal: boolean;
begin
  Result := fDisplayInCellTotal;
end;

function TGridTerm.getDisplayMaxValue: boolean;
begin
  Result := fDisplayMaxValue;
end;

function TGridTerm.getDisplayMinValue: boolean;
begin
  Result := fDisplayMinValue;
end;

function TGridTerm.getDisplayTotal: boolean;
begin
  Result := fDisplayTotal;
end;

end.

